// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Primary design header
//
// This header should be included by all source files instantiating the design.
// The class here is then constructed to instantiate the design.
// See the Verilator manual for examples.

#ifndef _Vxor_acc_H_
#define _Vxor_acc_H_

#include "verilated.h"
class Vxor_acc__Syms;
class VerilatedVcd;

//----------

VL_MODULE(Vxor_acc) {
  public:
    // CELLS
    // Public to allow access to /*verilator_public*/ items;
    // otherwise the application code can consider these internals.
    
    // PORTS
    // The application code writes and reads these signals to
    // propagate new values into/out from the Verilated model.
    VL_IN8(clock,0,0);
    VL_IN8(reset,0,0);
    VL_IN8(io_data_0,7,0);
    VL_IN8(io_data_1,7,0);
    VL_IN8(io_data_2,7,0);
    VL_IN8(io_data_3,7,0);
    VL_IN8(io_data_4,7,0);
    VL_IN8(io_data_5,7,0);
    VL_IN8(io_data_6,7,0);
    VL_IN8(io_data_7,7,0);
    VL_IN8(io_key_0,7,0);
    VL_IN8(io_key_1,7,0);
    VL_IN8(io_key_2,7,0);
    VL_IN8(io_key_3,7,0);
    VL_IN8(io_key_4,7,0);
    VL_IN8(io_key_5,7,0);
    VL_IN8(io_key_6,7,0);
    VL_IN8(io_key_7,7,0);
    VL_OUT8(io_xor_0,7,0);
    VL_OUT8(io_xor_1,7,0);
    VL_OUT8(io_xor_2,7,0);
    VL_OUT8(io_xor_3,7,0);
    VL_OUT8(io_xor_4,7,0);
    VL_OUT8(io_xor_5,7,0);
    VL_OUT8(io_xor_6,7,0);
    VL_OUT8(io_xor_7,7,0);
    //char	__VpadToAlign26[2];
    
    // LOCAL SIGNALS
    // Internals; generally not touched by application code
    
    // LOCAL VARIABLES
    // Internals; generally not touched by application code
    VL_SIG(__Vm_traceActivity,31,0);
    
    // INTERNAL VARIABLES
    // Internals; generally not touched by application code
    //char	__VpadToAlign44[4];
    Vxor_acc__Syms*	__VlSymsp;		// Symbol table
    
    // PARAMETERS
    // Parameters marked /*verilator public*/ for use by application code
    
    // CONSTRUCTORS
  private:
    Vxor_acc& operator= (const Vxor_acc&);	///< Copying not allowed
    Vxor_acc(const Vxor_acc&);	///< Copying not allowed
  public:
    /// Construct the model; called by application code
    /// The special name  may be used to make a wrapper with a
    /// single model invisible WRT DPI scope names.
    Vxor_acc(const char* name="TOP");
    /// Destroy the model; called (often implicitly) by application code
    ~Vxor_acc();
    /// Trace signals in the model; called by application code
    void trace (VerilatedVcdC* tfp, int levels, int options=0);
    
    // USER METHODS
    
    // API METHODS
    /// Evaluate the model.  Application must call when inputs change.
    void eval();
    /// Simulation complete, run final blocks.  Application must call on completion.
    void final();
    
    // INTERNAL METHODS
  private:
    static void _eval_initial_loop(Vxor_acc__Syms* __restrict vlSymsp);
  public:
    void __Vconfigure(Vxor_acc__Syms* symsp, bool first);
  private:
    static QData	_change_request(Vxor_acc__Syms* __restrict vlSymsp);
  public:
    static void	_combo__TOP__1(Vxor_acc__Syms* __restrict vlSymsp);
  private:
    void	_ctor_var_reset();
  public:
    static void	_eval(Vxor_acc__Syms* __restrict vlSymsp);
    static void	_eval_initial(Vxor_acc__Syms* __restrict vlSymsp);
    static void	_eval_settle(Vxor_acc__Syms* __restrict vlSymsp);
    static void	traceChgThis(Vxor_acc__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceChgThis__2(Vxor_acc__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceFullThis(Vxor_acc__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceFullThis__1(Vxor_acc__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceInitThis(Vxor_acc__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceInitThis__1(Vxor_acc__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void traceInit (VerilatedVcd* vcdp, void* userthis, uint32_t code);
    static void traceFull (VerilatedVcd* vcdp, void* userthis, uint32_t code);
    static void traceChg  (VerilatedVcd* vcdp, void* userthis, uint32_t code);
} VL_ATTR_ALIGNED(128);

#endif  /*guard*/
