// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Tracing implementation internals
#include "verilated_vcd_c.h"
#include "Vxor_acc__Syms.h"


//======================

void Vxor_acc::trace (VerilatedVcdC* tfp, int, int) {
    tfp->spTrace()->addCallback (&Vxor_acc::traceInit, &Vxor_acc::traceFull, &Vxor_acc::traceChg, this);
}
void Vxor_acc::traceInit(VerilatedVcd* vcdp, void* userthis, uint32_t code) {
    // Callback from vcd->open()
    Vxor_acc* t=(Vxor_acc*)userthis;
    Vxor_acc__Syms* __restrict vlSymsp = t->__VlSymsp; // Setup global symbol table
    if (!Verilated::calcUnusedSigs()) vl_fatal(__FILE__,__LINE__,__FILE__,"Turning on wave traces requires Verilated::traceEverOn(true) call before time 0.");
    vcdp->scopeEscape(' ');
    t->traceInitThis (vlSymsp, vcdp, code);
    vcdp->scopeEscape('.');
}
void Vxor_acc::traceFull(VerilatedVcd* vcdp, void* userthis, uint32_t code) {
    // Callback from vcd->dump()
    Vxor_acc* t=(Vxor_acc*)userthis;
    Vxor_acc__Syms* __restrict vlSymsp = t->__VlSymsp; // Setup global symbol table
    t->traceFullThis (vlSymsp, vcdp, code);
}

//======================


void Vxor_acc::traceInitThis(Vxor_acc__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code) {
    Vxor_acc* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    int c=code;
    if (0 && vcdp && c) {}  // Prevent unused
    vcdp->module(vlSymsp->name()); // Setup signal names
    // Body
    {
	vlTOPp->traceInitThis__1(vlSymsp, vcdp, code);
    }
}

void Vxor_acc::traceFullThis(Vxor_acc__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code) {
    Vxor_acc* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    int c=code;
    if (0 && vcdp && c) {}  // Prevent unused
    // Body
    {
	vlTOPp->traceFullThis__1(vlSymsp, vcdp, code);
    }
    // Final
    vlTOPp->__Vm_traceActivity = 0U;
}

void Vxor_acc::traceInitThis__1(Vxor_acc__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code) {
    Vxor_acc* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    int c=code;
    if (0 && vcdp && c) {}  // Prevent unused
    // Body
    {
	vcdp->declBit  (c+1,"clock",-1);
	vcdp->declBit  (c+2,"reset",-1);
	vcdp->declBus  (c+3,"io_data_0",-1,7,0);
	vcdp->declBus  (c+4,"io_data_1",-1,7,0);
	vcdp->declBus  (c+5,"io_data_2",-1,7,0);
	vcdp->declBus  (c+6,"io_data_3",-1,7,0);
	vcdp->declBus  (c+7,"io_data_4",-1,7,0);
	vcdp->declBus  (c+8,"io_data_5",-1,7,0);
	vcdp->declBus  (c+9,"io_data_6",-1,7,0);
	vcdp->declBus  (c+10,"io_data_7",-1,7,0);
	vcdp->declBus  (c+11,"io_key_0",-1,7,0);
	vcdp->declBus  (c+12,"io_key_1",-1,7,0);
	vcdp->declBus  (c+13,"io_key_2",-1,7,0);
	vcdp->declBus  (c+14,"io_key_3",-1,7,0);
	vcdp->declBus  (c+15,"io_key_4",-1,7,0);
	vcdp->declBus  (c+16,"io_key_5",-1,7,0);
	vcdp->declBus  (c+17,"io_key_6",-1,7,0);
	vcdp->declBus  (c+18,"io_key_7",-1,7,0);
	vcdp->declBus  (c+19,"io_xor_0",-1,7,0);
	vcdp->declBus  (c+20,"io_xor_1",-1,7,0);
	vcdp->declBus  (c+21,"io_xor_2",-1,7,0);
	vcdp->declBus  (c+22,"io_xor_3",-1,7,0);
	vcdp->declBus  (c+23,"io_xor_4",-1,7,0);
	vcdp->declBus  (c+24,"io_xor_5",-1,7,0);
	vcdp->declBus  (c+25,"io_xor_6",-1,7,0);
	vcdp->declBus  (c+26,"io_xor_7",-1,7,0);
	vcdp->declBit  (c+1,"xor_acc clock",-1);
	vcdp->declBit  (c+2,"xor_acc reset",-1);
	vcdp->declBus  (c+3,"xor_acc io_data_0",-1,7,0);
	vcdp->declBus  (c+4,"xor_acc io_data_1",-1,7,0);
	vcdp->declBus  (c+5,"xor_acc io_data_2",-1,7,0);
	vcdp->declBus  (c+6,"xor_acc io_data_3",-1,7,0);
	vcdp->declBus  (c+7,"xor_acc io_data_4",-1,7,0);
	vcdp->declBus  (c+8,"xor_acc io_data_5",-1,7,0);
	vcdp->declBus  (c+9,"xor_acc io_data_6",-1,7,0);
	vcdp->declBus  (c+10,"xor_acc io_data_7",-1,7,0);
	vcdp->declBus  (c+11,"xor_acc io_key_0",-1,7,0);
	vcdp->declBus  (c+12,"xor_acc io_key_1",-1,7,0);
	vcdp->declBus  (c+13,"xor_acc io_key_2",-1,7,0);
	vcdp->declBus  (c+14,"xor_acc io_key_3",-1,7,0);
	vcdp->declBus  (c+15,"xor_acc io_key_4",-1,7,0);
	vcdp->declBus  (c+16,"xor_acc io_key_5",-1,7,0);
	vcdp->declBus  (c+17,"xor_acc io_key_6",-1,7,0);
	vcdp->declBus  (c+18,"xor_acc io_key_7",-1,7,0);
	vcdp->declBus  (c+19,"xor_acc io_xor_0",-1,7,0);
	vcdp->declBus  (c+20,"xor_acc io_xor_1",-1,7,0);
	vcdp->declBus  (c+21,"xor_acc io_xor_2",-1,7,0);
	vcdp->declBus  (c+22,"xor_acc io_xor_3",-1,7,0);
	vcdp->declBus  (c+23,"xor_acc io_xor_4",-1,7,0);
	vcdp->declBus  (c+24,"xor_acc io_xor_5",-1,7,0);
	vcdp->declBus  (c+25,"xor_acc io_xor_6",-1,7,0);
	vcdp->declBus  (c+26,"xor_acc io_xor_7",-1,7,0);
	// Tracing: xor_acc _T_26 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/lab_and_zip/lab_hw_after_midterm/final_xor_acc/ChiselProject/test_run_dir/example.test.XOR_ACCTester1764432351/xor_acc.v:42
	// Tracing: xor_acc _T_27 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/lab_and_zip/lab_hw_after_midterm/final_xor_acc/ChiselProject/test_run_dir/example.test.XOR_ACCTester1764432351/xor_acc.v:43
	// Tracing: xor_acc _T_28 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/lab_and_zip/lab_hw_after_midterm/final_xor_acc/ChiselProject/test_run_dir/example.test.XOR_ACCTester1764432351/xor_acc.v:44
	// Tracing: xor_acc _T_29 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/lab_and_zip/lab_hw_after_midterm/final_xor_acc/ChiselProject/test_run_dir/example.test.XOR_ACCTester1764432351/xor_acc.v:45
	// Tracing: xor_acc _T_30 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/lab_and_zip/lab_hw_after_midterm/final_xor_acc/ChiselProject/test_run_dir/example.test.XOR_ACCTester1764432351/xor_acc.v:46
	// Tracing: xor_acc _T_31 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/lab_and_zip/lab_hw_after_midterm/final_xor_acc/ChiselProject/test_run_dir/example.test.XOR_ACCTester1764432351/xor_acc.v:47
	// Tracing: xor_acc _T_32 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/lab_and_zip/lab_hw_after_midterm/final_xor_acc/ChiselProject/test_run_dir/example.test.XOR_ACCTester1764432351/xor_acc.v:48
	// Tracing: xor_acc _T_33 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/lab_and_zip/lab_hw_after_midterm/final_xor_acc/ChiselProject/test_run_dir/example.test.XOR_ACCTester1764432351/xor_acc.v:49
    }
}

void Vxor_acc::traceFullThis__1(Vxor_acc__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code) {
    Vxor_acc* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    int c=code;
    if (0 && vcdp && c) {}  // Prevent unused
    // Body
    {
	vcdp->fullBit  (c+1,(vlTOPp->clock));
	vcdp->fullBit  (c+2,(vlTOPp->reset));
	vcdp->fullBus  (c+3,(vlTOPp->io_data_0),8);
	vcdp->fullBus  (c+4,(vlTOPp->io_data_1),8);
	vcdp->fullBus  (c+5,(vlTOPp->io_data_2),8);
	vcdp->fullBus  (c+6,(vlTOPp->io_data_3),8);
	vcdp->fullBus  (c+7,(vlTOPp->io_data_4),8);
	vcdp->fullBus  (c+8,(vlTOPp->io_data_5),8);
	vcdp->fullBus  (c+9,(vlTOPp->io_data_6),8);
	vcdp->fullBus  (c+10,(vlTOPp->io_data_7),8);
	vcdp->fullBus  (c+11,(vlTOPp->io_key_0),8);
	vcdp->fullBus  (c+12,(vlTOPp->io_key_1),8);
	vcdp->fullBus  (c+13,(vlTOPp->io_key_2),8);
	vcdp->fullBus  (c+14,(vlTOPp->io_key_3),8);
	vcdp->fullBus  (c+15,(vlTOPp->io_key_4),8);
	vcdp->fullBus  (c+16,(vlTOPp->io_key_5),8);
	vcdp->fullBus  (c+17,(vlTOPp->io_key_6),8);
	vcdp->fullBus  (c+18,(vlTOPp->io_key_7),8);
	vcdp->fullBus  (c+19,(vlTOPp->io_xor_0),8);
	vcdp->fullBus  (c+20,(vlTOPp->io_xor_1),8);
	vcdp->fullBus  (c+21,(vlTOPp->io_xor_2),8);
	vcdp->fullBus  (c+22,(vlTOPp->io_xor_3),8);
	vcdp->fullBus  (c+23,(vlTOPp->io_xor_4),8);
	vcdp->fullBus  (c+24,(vlTOPp->io_xor_5),8);
	vcdp->fullBus  (c+25,(vlTOPp->io_xor_6),8);
	vcdp->fullBus  (c+26,(vlTOPp->io_xor_7),8);
    }
}
