#include "Top.h"


Top::Top( sc_module_name n ): sc_module( n ){

    read_tlm = new ReadTLM( "readTLM" );
    sobel_tlm = new SobelTLM( "sobelTLM" );
    write_tlm = new WriteTLM( "writeTLM" );

    read_tlm->initiator.i_skt( sobel_tlm->t_skt_before_sobel );
    write_tlm->initiator.i_skt( sobel_tlm->t_skt_after_sobel );

}
