#ifndef WRITETLM_H_
#define WRITETLM_H_
#include <systemc>
using namespace sc_core;

#include "tlm"
// #include "tlm_utils/simple_target_socket.h"
#include "Initiator.h"

class WriteTLM: public sc_module
{
public:
    SC_HAS_PROCESS( WriteTLM );
    WriteTLM( sc_module_name n );
    Initiator initiator;
private:
    // define variable used in WriteTLM.cpp
    unsigned int   width;
    unsigned int   height;
    unsigned int   rgb_raw_data_offset;
    unsigned char  bit_per_pixel;
    unsigned char  byte_per_pixel;
    unsigned char* image_t;     // target image array
    void write_bmp();

    // declare transport function and some variable used in transport function
    unsigned char  *mask;
    unsigned int   base_offset;
};
#endif
