#ifndef _TOP_H_
#define _TOP_H_

#include <systemc>

#include "tlm_utils/simple_target_socket.h"
#include "Initiator.h"
#include "ReadTLM.h"
#include "SobelTLM.h"
#include "WriteTLM.h"

using namespace sc_core;

class Top: public sc_module {
public:
	SC_HAS_PROCESS( Top );
	Top( sc_module_name n );
	// Initiator initiator;
// private:
	ReadTLM * read_tlm;
	SobelTLM * sobel_tlm;
	WriteTLM * write_tlm;
};




#endif
