#include "Top.h"
#include "SimpleBus.h"
#include "sobel_tlm.h"

Top::Top( sc_module_name n ): sc_module( n ) {
    read_tlm = new ReadTLM( "readTLM" );
    sobel_tlm = new SobelTLM( "sobelTLM" );
    write_tlm = new WriteTLM( "writeTLM" );
    sobel = new Sobel( "sobel" );
}
