#include "Top.h"
#include "sobel_tlm.h"
#include "SimpleBus.h"

int sc_main(int argc, char* argv[]) {
    Top top("top");

    SimpleBus< 3, 2 > bus( "bus" );
    bus.set_clock_period( sc_core::sc_time( 1, SC_NS ) );

    top.read_tlm->initiator.i_skt( bus.target_socket[0] );
    top.write_tlm->initiator.i_skt( bus.target_socket[1] );
    top.sobel_tlm->initiator.i_skt( bus.target_socket[2] );

    bus.bindTargetSocket( top.sobel_tlm->t_skt_sobel, SOBEL_BASE, SOBEL_SIZE - 1, 0xff );
    bus.bindTargetSocket( top.sobel->targ_skt, HWSOBEL_BASE, HWSOBEL_BASE + HWSOBEL_SIZE - 1, 0xff );
    // bus.bindTargetSocket( top.sobel_tlm->t_skt_after_sobel, SOBEL_OUTPUT_BASE, SOBEL_OUTPUT_BASE + SOBEL_OUTPUT_SIZE - 1, 0xff );

    sc_start();
    return 0;
}
