#ifndef SOBEL_TLM_TYPES_H_
#define SOBEL_TLM_TYPES_H_

// #define MEMORY_BASE                      (0x00000000)
// #define MEMORY_INPUT_PPM_IMAGE_BEGIN     (0x00000000)
// #define MEMORY_OUTPUT_JPG_IMAGE_BEGIN    (0x00200000)
// #define MEMORY_SIZE                      (0x00400000)

// #define SOBEL_BASE                 (0x00000000)

// #define SOBEL_INPUT_WIDTH_OFFSET   (0x00000000)
// #define SOBEL_INPUT_HEIGHT_OFFSET  (0x00000004)
// #define SOBEL_INPUT_RGB_OFFSET     (0x00000008)
// #define SOBEL_INPUT_BIT_OFFSET     (0x0000000c)
// #define SOBEL_INPUT_BYTE_OFFSET    (0x0000000d)
// #define SOBEL_INPUT_IMAGES_OFFSET  (0x00000010)
// #define SOBEL_INPUT_IMAGET_OFFSET  (0x00000018)

// #define SOBEL_OUTPUT_WIDTH_OFFSET  (0x00000020)
// #define SOBEL_OUTPUT_HEIGHT_OFFSET (0x00000024)
// #define SOBEL_OUTPUT_RGB_OFFSET    (0x00000028)
// #define SOBEL_OUTPUT_BIT_OFFSET    (0x0000002c)
// #define SOBEL_OUTPUT_BYTE_OFFSET   (0x0000002d)
// #define SOBEL_OUTPUT_IMAGES_OFFSET (0x00000030)
// #define SOBEL_OUTPUT_IMAGET_OFFSET (0x00000038)

// #define SOBEL_SIZE                 (0x00000040)

#define SOBEL_BASE                 (0x00000000)
#define SOBEL_INPUT_WIDTH_OFFSET   (0x00000000)
#define SOBEL_INPUT_HEIGHT_OFFSET  (0x00000004)
#define SOBEL_INPUT_RGB_OFFSET     (0x00000008)
#define SOBEL_INPUT_BIT_OFFSET     (0x0000000c)
#define SOBEL_INPUT_BYTE_OFFSET    (0x0000000d)
#define SOBEL_INPUT_IMAGES_OFFSET  (0x00000010)
#define SOBEL_INPUT_IMAGET_OFFSET  (0x00000018)
// #define SOBEL_INPUT_SIZE           (0x00000020)

// #define SOBEL_OUTPUT_BASE          (0x00000100)
#define SOBEL_OUTPUT_WIDTH_OFFSET  (0x00000020)
#define SOBEL_OUTPUT_HEIGHT_OFFSET (0x00000024)
#define SOBEL_OUTPUT_RGB_OFFSET    (0x00000028)
#define SOBEL_OUTPUT_BIT_OFFSET    (0x0000002c)
#define SOBEL_OUTPUT_BYTE_OFFSET   (0x0000002d)
#define SOBEL_OUTPUT_IMAGES_OFFSET (0x00000030)
#define SOBEL_OUTPUT_IMAGET_OFFSET (0x00000038)
#define SOBEL_SIZE                 (0X00000040)
// #define SOBEL_OUTPUT_SIZE          (0x00000020)

#define HWSOBEL_BASE               (0x00000100)
#define HWSOBEL_INPUT_OFFSET       (0x00000000)
#define HWSOBEL_OUTPUT_OFFSET      (0x00000004)
#define HWSOBEL_SIZE               (0x00000008)


typedef union word {
    int sint;
    unsigned int uint;
    unsigned char uc[4];
} word;

struct ReturnValue {
  unsigned int iVal1;
  unsigned int iVal2;
};

#endif
