// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Design implementation internals
// See Vsobel.h for the primary calling header

#include "Vsobel.h"            // For This
#include "Vsobel__Syms.h"

//--------------------
// STATIC VARIABLES


//--------------------

VL_CTOR_IMP(Vsobel) {
    Vsobel__Syms* __restrict vlSymsp = __VlSymsp = new Vsobel__Syms(this, name());
    Vsobel* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Reset internal values
    
    // Reset structure values
    clock = VL_RAND_RESET_I(1);
    reset = VL_RAND_RESET_I(1);
    io_m0 = VL_RAND_RESET_I(10);
    io_m1 = VL_RAND_RESET_I(10);
    io_m2 = VL_RAND_RESET_I(10);
    io_m3 = VL_RAND_RESET_I(10);
    io_m5 = VL_RAND_RESET_I(10);
    io_m6 = VL_RAND_RESET_I(10);
    io_m7 = VL_RAND_RESET_I(10);
    io_m8 = VL_RAND_RESET_I(10);
    io_out_X = VL_RAND_RESET_I(10);
    io_out_Y = VL_RAND_RESET_I(10);
    v__DOT___T_16 = VL_RAND_RESET_I(11);
    v__DOT___T_21 = VL_RAND_RESET_I(11);
    v__DOT___T_36 = VL_RAND_RESET_I(11);
    v__DOT___T_41 = VL_RAND_RESET_I(11);
    __Vm_traceActivity = VL_RAND_RESET_I(32);
}

void Vsobel::__Vconfigure(Vsobel__Syms* vlSymsp, bool first) {
    if (0 && first) {}  // Prevent unused
    this->__VlSymsp = vlSymsp;
}

Vsobel::~Vsobel() {
    delete __VlSymsp; __VlSymsp=NULL;
}

//--------------------


void Vsobel::eval() {
    Vsobel__Syms* __restrict vlSymsp = this->__VlSymsp; // Setup global symbol table
    Vsobel* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Initialize
    if (VL_UNLIKELY(!vlSymsp->__Vm_didInit)) _eval_initial_loop(vlSymsp);
    // Evaluate till stable
    VL_DEBUG_IF(VL_PRINTF("\n----TOP Evaluate Vsobel::eval\n"); );
    int __VclockLoop = 0;
    IData __Vchange=1;
    while (VL_LIKELY(__Vchange)) {
	VL_DEBUG_IF(VL_PRINTF(" Clock loop\n"););
	vlSymsp->__Vm_activity = true;
	_eval(vlSymsp);
	__Vchange = _change_request(vlSymsp);
	if (++__VclockLoop > 100) vl_fatal(__FILE__,__LINE__,__FILE__,"Verilated model didn't converge");
    }
}

void Vsobel::_eval_initial_loop(Vsobel__Syms* __restrict vlSymsp) {
    vlSymsp->__Vm_didInit = true;
    _eval_initial(vlSymsp);
    vlSymsp->__Vm_activity = true;
    int __VclockLoop = 0;
    IData __Vchange=1;
    while (VL_LIKELY(__Vchange)) {
	_eval_settle(vlSymsp);
	_eval(vlSymsp);
	__Vchange = _change_request(vlSymsp);
	if (++__VclockLoop > 100) vl_fatal(__FILE__,__LINE__,__FILE__,"Verilated model didn't DC converge");
    }
}

//--------------------
// Internal Methods

void Vsobel::_combo__TOP__1(Vsobel__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vsobel::_combo__TOP__1\n"); );
    Vsobel* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->v__DOT___T_16 = (0x7ff & ((0x3ff & (((IData)(vlTOPp->io_m0) 
						 + (IData)(vlTOPp->io_m1)) 
						+ (IData)(vlTOPp->io_m1))) 
				      + (IData)(vlTOPp->io_m2)));
    vlTOPp->v__DOT___T_21 = (0x7ff & ((0x3ff & (((IData)(vlTOPp->io_m6) 
						 + (IData)(vlTOPp->io_m7)) 
						+ (IData)(vlTOPp->io_m7))) 
				      + (IData)(vlTOPp->io_m8)));
    vlTOPp->v__DOT___T_36 = (0x7ff & ((0x3ff & (((IData)(vlTOPp->io_m0) 
						 + (IData)(vlTOPp->io_m3)) 
						+ (IData)(vlTOPp->io_m3))) 
				      + (IData)(vlTOPp->io_m6)));
    vlTOPp->v__DOT___T_41 = (0x7ff & ((0x3ff & (((IData)(vlTOPp->io_m2) 
						 + (IData)(vlTOPp->io_m5)) 
						+ (IData)(vlTOPp->io_m5))) 
				      + (IData)(vlTOPp->io_m8)));
}

void Vsobel::_settle__TOP__2(Vsobel__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vsobel::_settle__TOP__2\n"); );
    Vsobel* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->v__DOT___T_16 = (0x7ff & ((0x3ff & (((IData)(vlTOPp->io_m0) 
						 + (IData)(vlTOPp->io_m1)) 
						+ (IData)(vlTOPp->io_m1))) 
				      + (IData)(vlTOPp->io_m2)));
    vlTOPp->v__DOT___T_21 = (0x7ff & ((0x3ff & (((IData)(vlTOPp->io_m6) 
						 + (IData)(vlTOPp->io_m7)) 
						+ (IData)(vlTOPp->io_m7))) 
				      + (IData)(vlTOPp->io_m8)));
    vlTOPp->v__DOT___T_36 = (0x7ff & ((0x3ff & (((IData)(vlTOPp->io_m0) 
						 + (IData)(vlTOPp->io_m3)) 
						+ (IData)(vlTOPp->io_m3))) 
				      + (IData)(vlTOPp->io_m6)));
    vlTOPp->v__DOT___T_41 = (0x7ff & ((0x3ff & (((IData)(vlTOPp->io_m2) 
						 + (IData)(vlTOPp->io_m5)) 
						+ (IData)(vlTOPp->io_m5))) 
				      + (IData)(vlTOPp->io_m8)));
    vlTOPp->io_out_X = (0x3ff & (((0x3ff & (IData)(vlTOPp->v__DOT___T_16)) 
				  > (0x3ff & (IData)(vlTOPp->v__DOT___T_21)))
				  ? ((IData)(vlTOPp->v__DOT___T_16) 
				     - (IData)(vlTOPp->v__DOT___T_21))
				  : ((IData)(vlTOPp->v__DOT___T_21) 
				     - (IData)(vlTOPp->v__DOT___T_16))));
    vlTOPp->io_out_Y = (0x3ff & (((0x3ff & (IData)(vlTOPp->v__DOT___T_36)) 
				  > (0x3ff & (IData)(vlTOPp->v__DOT___T_41)))
				  ? ((IData)(vlTOPp->v__DOT___T_36) 
				     - (IData)(vlTOPp->v__DOT___T_41))
				  : ((IData)(vlTOPp->v__DOT___T_41) 
				     - (IData)(vlTOPp->v__DOT___T_36))));
}

void Vsobel::_combo__TOP__3(Vsobel__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vsobel::_combo__TOP__3\n"); );
    Vsobel* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->io_out_X = (0x3ff & (((0x3ff & (IData)(vlTOPp->v__DOT___T_16)) 
				  > (0x3ff & (IData)(vlTOPp->v__DOT___T_21)))
				  ? ((IData)(vlTOPp->v__DOT___T_16) 
				     - (IData)(vlTOPp->v__DOT___T_21))
				  : ((IData)(vlTOPp->v__DOT___T_21) 
				     - (IData)(vlTOPp->v__DOT___T_16))));
    vlTOPp->io_out_Y = (0x3ff & (((0x3ff & (IData)(vlTOPp->v__DOT___T_36)) 
				  > (0x3ff & (IData)(vlTOPp->v__DOT___T_41)))
				  ? ((IData)(vlTOPp->v__DOT___T_36) 
				     - (IData)(vlTOPp->v__DOT___T_41))
				  : ((IData)(vlTOPp->v__DOT___T_41) 
				     - (IData)(vlTOPp->v__DOT___T_36))));
}

void Vsobel::_eval(Vsobel__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vsobel::_eval\n"); );
    Vsobel* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->_combo__TOP__1(vlSymsp);
    vlTOPp->__Vm_traceActivity = (2 | vlTOPp->__Vm_traceActivity);
    vlTOPp->_combo__TOP__3(vlSymsp);
}

void Vsobel::_eval_initial(Vsobel__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vsobel::_eval_initial\n"); );
    Vsobel* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
}

void Vsobel::final() {
    VL_DEBUG_IF(VL_PRINTF("    Vsobel::final\n"); );
    // Variables
    Vsobel__Syms* __restrict vlSymsp = this->__VlSymsp;
    Vsobel* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
}

void Vsobel::_eval_settle(Vsobel__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vsobel::_eval_settle\n"); );
    Vsobel* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->_settle__TOP__2(vlSymsp);
    vlTOPp->__Vm_traceActivity = (1 | vlTOPp->__Vm_traceActivity);
}

IData Vsobel::_change_request(Vsobel__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vsobel::_change_request\n"); );
    Vsobel* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    // Change detection
    IData __req = false;  // Logically a bool
    return __req;
}
