// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Primary design header
//
// This header should be included by all source files instantiating the design.
// The class here is then constructed to instantiate the design.
// See the Verilator manual for examples.

#ifndef _Vsobel_H_
#define _Vsobel_H_

#include "verilated.h"
class Vsobel__Syms;
class VerilatedVcd;

//----------

VL_MODULE(Vsobel) {
  public:
    // CELLS
    // Public to allow access to /*verilator_public*/ items;
    // otherwise the application code can consider these internals.
    
    // PORTS
    // The application code writes and reads these signals to
    // propagate new values into/out from the Verilated model.
    VL_IN8(clock,0,0);
    VL_IN8(reset,0,0);
    VL_IN16(io_m0,9,0);
    VL_IN16(io_m1,9,0);
    VL_IN16(io_m2,9,0);
    VL_IN16(io_m3,9,0);
    VL_IN16(io_m5,9,0);
    VL_IN16(io_m6,9,0);
    VL_IN16(io_m7,9,0);
    VL_IN16(io_m8,9,0);
    VL_OUT16(io_out_X,9,0);
    VL_OUT16(io_out_Y,9,0);
    //char	__VpadToAlign22[2];
    
    // LOCAL SIGNALS
    // Internals; generally not touched by application code
    VL_SIG16(v__DOT___T_16,10,0);
    VL_SIG16(v__DOT___T_21,10,0);
    VL_SIG16(v__DOT___T_36,10,0);
    VL_SIG16(v__DOT___T_41,10,0);
    
    // LOCAL VARIABLES
    // Internals; generally not touched by application code
    VL_SIG(__Vm_traceActivity,31,0);
    
    // INTERNAL VARIABLES
    // Internals; generally not touched by application code
    Vsobel__Syms*	__VlSymsp;		// Symbol table
    
    // PARAMETERS
    // Parameters marked /*verilator public*/ for use by application code
    
    // CONSTRUCTORS
  private:
    Vsobel& operator= (const Vsobel&);	///< Copying not allowed
    Vsobel(const Vsobel&);	///< Copying not allowed
  public:
    /// Construct the model; called by application code
    /// The special name  may be used to make a wrapper with a
    /// single model invisible WRT DPI scope names.
    Vsobel(const char* name="TOP");
    /// Destroy the model; called (often implicitly) by application code
    ~Vsobel();
    /// Trace signals in the model; called by application code
    void trace (VerilatedVcdC* tfp, int levels, int options=0);
    
    // USER METHODS
    
    // API METHODS
    /// Evaluate the model.  Application must call when inputs change.
    void eval();
    /// Simulation complete, run final blocks.  Application must call on completion.
    void final();
    
    // INTERNAL METHODS
  private:
    static void _eval_initial_loop(Vsobel__Syms* __restrict vlSymsp);
  public:
    void __Vconfigure(Vsobel__Syms* symsp, bool first);
  private:
    static IData	_change_request(Vsobel__Syms* __restrict vlSymsp);
  public:
    static void	_combo__TOP__1(Vsobel__Syms* __restrict vlSymsp);
    static void	_combo__TOP__3(Vsobel__Syms* __restrict vlSymsp);
    static void	_eval(Vsobel__Syms* __restrict vlSymsp);
    static void	_eval_initial(Vsobel__Syms* __restrict vlSymsp);
    static void	_eval_settle(Vsobel__Syms* __restrict vlSymsp);
    static void	_settle__TOP__2(Vsobel__Syms* __restrict vlSymsp);
    static void	traceChgThis(Vsobel__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceChgThis__2(Vsobel__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceChgThis__3(Vsobel__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceFullThis(Vsobel__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceFullThis__1(Vsobel__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceInitThis(Vsobel__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceInitThis__1(Vsobel__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void traceInit (VerilatedVcd* vcdp, void* userthis, uint32_t code);
    static void traceFull (VerilatedVcd* vcdp, void* userthis, uint32_t code);
    static void traceChg  (VerilatedVcd* vcdp, void* userthis, uint32_t code);
} VL_ATTR_ALIGNED(128);

#endif  /*guard*/
