#include <stdio.h>
#include <assert.h>

#include "sync.h"


//user will overwrite this function
extern void thread_entry(int cid, int nc);


int compare_and_swap(volatile int *reg, int oldval, int newval) {
  /* 
   * This is a semi-hosting function. 
   * The operation is done in OVP semi-hosting lib.
   *
   * If the value in reg is the same as oldval, 
   *    assign newval to reg and return 1.
   * Otherwise do nothing, return 0.
   *
   * */ 
  assert(0);
  return 0;
}

int get_threadsense() {
  assert(0);
  return 0;
}

void set_threadsense(int val){
  assert(0);
}

int fetch_and_add( void* mem, int val ) {
    assert(0);
    return 0;
}



void mutex_lock( volatile Mutex* mutex ) {
    while( !compare_and_swap( &mutex->state, FREE, LOCKED ) );
}

void mutex_unlock( volatile Mutex* mutex ) {
    assert( compare_and_swap( &mutex->state, LOCKED, FREE ) );
}


void barrier(const unsigned nwait) {
    static int narrived = -1; 
    static int sense;
    set_threadsense(!get_threadsense());
    
    if ( fetch_and_add((void*)&narrived, 1) == nwait-2 ) {
        narrived = -1;
        sense = get_threadsense();
    }
    else while( sense != get_threadsense() ) 
        ;
}

int gethartid() {
  assert(0);
  return 0;
}

int main(int argc, char** argv) {

    int ncore = NCORE;
    int coreid = gethartid();
    thread_entry(coreid, ncore);
  
    barrier(ncore);
    return 0;
}
