// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Symbol table internal header
//
// Internal details; most calling programs do not need this header

#ifndef _Vhybrid__Syms_H_
#define _Vhybrid__Syms_H_

#include "verilated.h"

// INCLUDE MODULE CLASSES
#include "Vhybrid.h"
#include "Vhybrid_median5.h"

// SYMS CLASS
class Vhybrid__Syms : public VerilatedSyms {
  public:
    
    // LOCAL STATE
    const char* __Vm_namep;
    bool	__Vm_activity;		///< Used by trace routines to determine change occurred
    bool	__Vm_didInit;
    //char	__VpadToAlign10[6];
    
    // SUBCELL STATE
    Vhybrid*                       TOPp;
    Vhybrid_median5                TOP__hybrid__DOT__B_0;
    Vhybrid_median5                TOP__hybrid__DOT__B_1;
    Vhybrid_median5                TOP__hybrid__DOT__G_0;
    Vhybrid_median5                TOP__hybrid__DOT__G_1;
    Vhybrid_median5                TOP__hybrid__DOT__R_0;
    Vhybrid_median5                TOP__hybrid__DOT__R_1;
    
    // COVERAGE
    
    // SCOPE NAMES
    
    // CREATORS
    Vhybrid__Syms(Vhybrid* topp, const char* namep);
    ~Vhybrid__Syms() {};
    
    // METHODS
    inline const char* name() { return __Vm_namep; }
    inline bool getClearActivity() { bool r=__Vm_activity; __Vm_activity=false; return r;}
    
} VL_ATTR_ALIGNED(64);

#endif  /*guard*/
