`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif

module median5(
  input        clock,
  input  [7:0] io_x0,
  input  [7:0] io_x1,
  input  [7:0] io_x2,
  input  [7:0] io_x3,
  input  [7:0] io_x4,
  input  [4:0] io_cnt,
  input        io_e,
  output [7:0] io_z
);
  reg [7:0] tbl_0;
  reg [31:0] _RAND_0;
  reg [7:0] tbl_1;
  reg [31:0] _RAND_1;
  reg [7:0] tbl_2;
  reg [31:0] _RAND_2;
  reg [7:0] tbl_3;
  reg [31:0] _RAND_3;
  reg [7:0] tbl_4;
  reg [31:0] _RAND_4;
  wire [7:0] _GEN_0;
  wire [7:0] _GEN_1;
  wire [7:0] _GEN_2;
  wire [7:0] _GEN_3;
  wire [7:0] _GEN_4;
  wire  _T_21;
  wire  _T_22;
  wire [7:0] _GEN_5;
  wire [7:0] _GEN_6;
  wire [7:0] _GEN_7;
  wire [7:0] _GEN_8;
  wire  _T_24;
  wire  _T_25;
  wire [7:0] _GEN_9;
  wire [7:0] _GEN_10;
  wire [7:0] _GEN_11;
  wire [7:0] _GEN_12;
  wire  _T_27;
  wire  _T_28;
  wire [7:0] _GEN_13;
  wire [7:0] _GEN_14;
  wire [7:0] _GEN_15;
  wire [7:0] _GEN_16;
  wire  _T_30;
  wire  _T_31;
  wire [7:0] _GEN_17;
  wire [7:0] _GEN_18;
  wire [7:0] _GEN_19;
  wire [7:0] _GEN_20;
  wire  _T_33;
  wire [7:0] _GEN_21;
  wire [7:0] _GEN_22;
  wire [7:0] _GEN_23;
  wire [7:0] _GEN_24;
  wire  _T_36;
  wire [7:0] _GEN_25;
  wire [7:0] _GEN_26;
  wire [7:0] _GEN_27;
  wire [7:0] _GEN_28;
  wire  _T_39;
  wire [7:0] _GEN_29;
  wire [7:0] _GEN_30;
  wire [7:0] _GEN_31;
  wire [7:0] _GEN_32;
  wire  _T_42;
  wire [7:0] _GEN_33;
  wire [7:0] _GEN_34;
  wire [7:0] _GEN_35;
  wire [7:0] _GEN_36;
  wire  _T_45;
  wire [7:0] _GEN_37;
  wire [7:0] _GEN_38;
  wire [7:0] _GEN_39;
  wire [7:0] _GEN_40;
  wire  _T_48;
  wire [7:0] _GEN_41;
  wire [7:0] _GEN_42;
  wire [7:0] _GEN_43;
  wire [7:0] _GEN_44;
  wire  _T_51;
  wire [7:0] _GEN_45;
  wire [7:0] _GEN_46;
  wire [7:0] _GEN_47;
  wire [7:0] _GEN_48;
  wire  _T_54;
  wire [7:0] _GEN_49;
  wire [7:0] _GEN_50;
  wire [7:0] _GEN_51;
  wire [7:0] _GEN_52;
  wire  _T_57;
  wire [7:0] _GEN_53;
  wire [7:0] _GEN_54;
  wire [7:0] _GEN_55;
  wire [7:0] _GEN_56;
  wire  _T_60;
  wire [7:0] _GEN_57;
  wire [7:0] _GEN_58;
  wire [7:0] _GEN_59;
  wire [7:0] _GEN_60;
  wire  _T_63;
  wire [7:0] _GEN_61;
  wire [7:0] _GEN_62;
  wire [7:0] _GEN_63;
  wire [7:0] _GEN_64;
  wire  _T_66;
  wire [7:0] _GEN_65;
  wire [7:0] _GEN_66;
  wire [7:0] _GEN_67;
  wire [7:0] _GEN_68;
  wire  _T_69;
  wire [7:0] _GEN_69;
  wire [7:0] _GEN_70;
  wire [7:0] _GEN_71;
  wire [7:0] _GEN_72;
  wire  _T_72;
  wire [7:0] _GEN_73;
  wire [7:0] _GEN_74;
  wire [7:0] _GEN_75;
  wire [7:0] _GEN_76;
  wire  _T_75;
  wire [7:0] _GEN_77;
  wire [7:0] _GEN_78;
  wire [7:0] _GEN_79;
  wire [7:0] _GEN_80;
  wire  _T_78;
  wire [7:0] _GEN_81;
  wire [7:0] _GEN_82;
  wire [7:0] _GEN_83;
  wire [7:0] _GEN_84;
  assign _GEN_0 = io_e ? io_x0 : tbl_0;
  assign _GEN_1 = io_e ? io_x1 : tbl_1;
  assign _GEN_2 = io_e ? io_x2 : tbl_2;
  assign _GEN_3 = io_e ? io_x3 : tbl_3;
  assign _GEN_4 = io_e ? io_x4 : tbl_4;
  assign _T_21 = io_cnt == 5'h1;
  assign _T_22 = tbl_1 < tbl_0;
  assign _GEN_5 = _T_22 ? tbl_0 : _GEN_1;
  assign _GEN_6 = _T_22 ? tbl_1 : _GEN_0;
  assign _GEN_7 = _T_21 ? _GEN_5 : _GEN_1;
  assign _GEN_8 = _T_21 ? _GEN_6 : _GEN_0;
  assign _T_24 = io_cnt == 5'h2;
  assign _T_25 = tbl_2 < tbl_1;
  assign _GEN_9 = _T_25 ? tbl_1 : _GEN_2;
  assign _GEN_10 = _T_25 ? tbl_2 : _GEN_7;
  assign _GEN_11 = _T_24 ? _GEN_9 : _GEN_2;
  assign _GEN_12 = _T_24 ? _GEN_10 : _GEN_7;
  assign _T_27 = io_cnt == 5'h3;
  assign _T_28 = tbl_3 < tbl_2;
  assign _GEN_13 = _T_28 ? tbl_2 : _GEN_3;
  assign _GEN_14 = _T_28 ? tbl_3 : _GEN_11;
  assign _GEN_15 = _T_27 ? _GEN_13 : _GEN_3;
  assign _GEN_16 = _T_27 ? _GEN_14 : _GEN_11;
  assign _T_30 = io_cnt == 5'h4;
  assign _T_31 = tbl_4 < tbl_3;
  assign _GEN_17 = _T_31 ? tbl_3 : _GEN_4;
  assign _GEN_18 = _T_31 ? tbl_4 : _GEN_15;
  assign _GEN_19 = _T_30 ? _GEN_17 : _GEN_4;
  assign _GEN_20 = _T_30 ? _GEN_18 : _GEN_15;
  assign _T_33 = io_cnt == 5'h5;
  assign _GEN_21 = _T_22 ? tbl_0 : _GEN_12;
  assign _GEN_22 = _T_22 ? tbl_1 : _GEN_8;
  assign _GEN_23 = _T_33 ? _GEN_21 : _GEN_12;
  assign _GEN_24 = _T_33 ? _GEN_22 : _GEN_8;
  assign _T_36 = io_cnt == 5'h6;
  assign _GEN_25 = _T_25 ? tbl_1 : _GEN_16;
  assign _GEN_26 = _T_25 ? tbl_2 : _GEN_23;
  assign _GEN_27 = _T_36 ? _GEN_25 : _GEN_16;
  assign _GEN_28 = _T_36 ? _GEN_26 : _GEN_23;
  assign _T_39 = io_cnt == 5'h7;
  assign _GEN_29 = _T_28 ? tbl_2 : _GEN_20;
  assign _GEN_30 = _T_28 ? tbl_3 : _GEN_27;
  assign _GEN_31 = _T_39 ? _GEN_29 : _GEN_20;
  assign _GEN_32 = _T_39 ? _GEN_30 : _GEN_27;
  assign _T_42 = io_cnt == 5'h8;
  assign _GEN_33 = _T_31 ? tbl_3 : _GEN_19;
  assign _GEN_34 = _T_31 ? tbl_4 : _GEN_31;
  assign _GEN_35 = _T_42 ? _GEN_33 : _GEN_19;
  assign _GEN_36 = _T_42 ? _GEN_34 : _GEN_31;
  assign _T_45 = io_cnt == 5'h9;
  assign _GEN_37 = _T_22 ? tbl_0 : _GEN_28;
  assign _GEN_38 = _T_22 ? tbl_1 : _GEN_24;
  assign _GEN_39 = _T_45 ? _GEN_37 : _GEN_28;
  assign _GEN_40 = _T_45 ? _GEN_38 : _GEN_24;
  assign _T_48 = io_cnt == 5'ha;
  assign _GEN_41 = _T_25 ? tbl_1 : _GEN_32;
  assign _GEN_42 = _T_25 ? tbl_2 : _GEN_39;
  assign _GEN_43 = _T_48 ? _GEN_41 : _GEN_32;
  assign _GEN_44 = _T_48 ? _GEN_42 : _GEN_39;
  assign _T_51 = io_cnt == 5'hb;
  assign _GEN_45 = _T_28 ? tbl_2 : _GEN_36;
  assign _GEN_46 = _T_28 ? tbl_3 : _GEN_43;
  assign _GEN_47 = _T_51 ? _GEN_45 : _GEN_36;
  assign _GEN_48 = _T_51 ? _GEN_46 : _GEN_43;
  assign _T_54 = io_cnt == 5'hc;
  assign _GEN_49 = _T_31 ? tbl_3 : _GEN_35;
  assign _GEN_50 = _T_31 ? tbl_4 : _GEN_47;
  assign _GEN_51 = _T_54 ? _GEN_49 : _GEN_35;
  assign _GEN_52 = _T_54 ? _GEN_50 : _GEN_47;
  assign _T_57 = io_cnt == 5'hd;
  assign _GEN_53 = _T_22 ? tbl_0 : _GEN_44;
  assign _GEN_54 = _T_22 ? tbl_1 : _GEN_40;
  assign _GEN_55 = _T_57 ? _GEN_53 : _GEN_44;
  assign _GEN_56 = _T_57 ? _GEN_54 : _GEN_40;
  assign _T_60 = io_cnt == 5'he;
  assign _GEN_57 = _T_25 ? tbl_1 : _GEN_48;
  assign _GEN_58 = _T_25 ? tbl_2 : _GEN_55;
  assign _GEN_59 = _T_60 ? _GEN_57 : _GEN_48;
  assign _GEN_60 = _T_60 ? _GEN_58 : _GEN_55;
  assign _T_63 = io_cnt == 5'hf;
  assign _GEN_61 = _T_28 ? tbl_2 : _GEN_52;
  assign _GEN_62 = _T_28 ? tbl_3 : _GEN_59;
  assign _GEN_63 = _T_63 ? _GEN_61 : _GEN_52;
  assign _GEN_64 = _T_63 ? _GEN_62 : _GEN_59;
  assign _T_66 = io_cnt == 5'h10;
  assign _GEN_65 = _T_31 ? tbl_3 : _GEN_51;
  assign _GEN_66 = _T_31 ? tbl_4 : _GEN_63;
  assign _GEN_67 = _T_66 ? _GEN_65 : _GEN_51;
  assign _GEN_68 = _T_66 ? _GEN_66 : _GEN_63;
  assign _T_69 = io_cnt == 5'h11;
  assign _GEN_69 = _T_22 ? tbl_0 : _GEN_60;
  assign _GEN_70 = _T_22 ? tbl_1 : _GEN_56;
  assign _GEN_71 = _T_69 ? _GEN_69 : _GEN_60;
  assign _GEN_72 = _T_69 ? _GEN_70 : _GEN_56;
  assign _T_72 = io_cnt == 5'h12;
  assign _GEN_73 = _T_25 ? tbl_1 : _GEN_64;
  assign _GEN_74 = _T_25 ? tbl_2 : _GEN_71;
  assign _GEN_75 = _T_72 ? _GEN_73 : _GEN_64;
  assign _GEN_76 = _T_72 ? _GEN_74 : _GEN_71;
  assign _T_75 = io_cnt == 5'h13;
  assign _GEN_77 = _T_28 ? tbl_2 : _GEN_68;
  assign _GEN_78 = _T_28 ? tbl_3 : _GEN_75;
  assign _GEN_79 = _T_75 ? _GEN_77 : _GEN_68;
  assign _GEN_80 = _T_75 ? _GEN_78 : _GEN_75;
  assign _T_78 = io_cnt == 5'h14;
  assign _GEN_81 = _T_31 ? tbl_3 : _GEN_67;
  assign _GEN_82 = _T_31 ? tbl_4 : _GEN_79;
  assign _GEN_83 = _T_78 ? _GEN_81 : _GEN_67;
  assign _GEN_84 = _T_78 ? _GEN_82 : _GEN_79;
  assign io_z = tbl_2;
`ifdef RANDOMIZE
  integer initvar;
  initial begin
    `ifndef verilator
      #0.002 begin end
    `endif
  `ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{$random}};
  tbl_0 = _RAND_0[7:0];
  `endif // RANDOMIZE_REG_INIT
  `ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{$random}};
  tbl_1 = _RAND_1[7:0];
  `endif // RANDOMIZE_REG_INIT
  `ifdef RANDOMIZE_REG_INIT
  _RAND_2 = {1{$random}};
  tbl_2 = _RAND_2[7:0];
  `endif // RANDOMIZE_REG_INIT
  `ifdef RANDOMIZE_REG_INIT
  _RAND_3 = {1{$random}};
  tbl_3 = _RAND_3[7:0];
  `endif // RANDOMIZE_REG_INIT
  `ifdef RANDOMIZE_REG_INIT
  _RAND_4 = {1{$random}};
  tbl_4 = _RAND_4[7:0];
  `endif // RANDOMIZE_REG_INIT
  end
`endif // RANDOMIZE
  always @(posedge clock) begin
    if (_T_69) begin
      if (_T_22) begin
        tbl_0 <= tbl_1;
      end else begin
        if (_T_57) begin
          if (_T_22) begin
            tbl_0 <= tbl_1;
          end else begin
            if (_T_45) begin
              if (_T_22) begin
                tbl_0 <= tbl_1;
              end else begin
                if (_T_33) begin
                  if (_T_22) begin
                    tbl_0 <= tbl_1;
                  end else begin
                    if (_T_21) begin
                      if (_T_22) begin
                        tbl_0 <= tbl_1;
                      end else begin
                        if (io_e) begin
                          tbl_0 <= io_x0;
                        end
                      end
                    end else begin
                      if (io_e) begin
                        tbl_0 <= io_x0;
                      end
                    end
                  end
                end else begin
                  if (_T_21) begin
                    if (_T_22) begin
                      tbl_0 <= tbl_1;
                    end else begin
                      if (io_e) begin
                        tbl_0 <= io_x0;
                      end
                    end
                  end else begin
                    if (io_e) begin
                      tbl_0 <= io_x0;
                    end
                  end
                end
              end
            end else begin
              if (_T_33) begin
                if (_T_22) begin
                  tbl_0 <= tbl_1;
                end else begin
                  if (_T_21) begin
                    if (_T_22) begin
                      tbl_0 <= tbl_1;
                    end else begin
                      tbl_0 <= _GEN_0;
                    end
                  end else begin
                    tbl_0 <= _GEN_0;
                  end
                end
              end else begin
                if (_T_21) begin
                  if (_T_22) begin
                    tbl_0 <= tbl_1;
                  end else begin
                    tbl_0 <= _GEN_0;
                  end
                end else begin
                  tbl_0 <= _GEN_0;
                end
              end
            end
          end
        end else begin
          if (_T_45) begin
            if (_T_22) begin
              tbl_0 <= tbl_1;
            end else begin
              if (_T_33) begin
                if (_T_22) begin
                  tbl_0 <= tbl_1;
                end else begin
                  tbl_0 <= _GEN_8;
                end
              end else begin
                tbl_0 <= _GEN_8;
              end
            end
          end else begin
            if (_T_33) begin
              if (_T_22) begin
                tbl_0 <= tbl_1;
              end else begin
                tbl_0 <= _GEN_8;
              end
            end else begin
              tbl_0 <= _GEN_8;
            end
          end
        end
      end
    end else begin
      if (_T_57) begin
        if (_T_22) begin
          tbl_0 <= tbl_1;
        end else begin
          if (_T_45) begin
            if (_T_22) begin
              tbl_0 <= tbl_1;
            end else begin
              tbl_0 <= _GEN_24;
            end
          end else begin
            tbl_0 <= _GEN_24;
          end
        end
      end else begin
        if (_T_45) begin
          if (_T_22) begin
            tbl_0 <= tbl_1;
          end else begin
            tbl_0 <= _GEN_24;
          end
        end else begin
          tbl_0 <= _GEN_24;
        end
      end
    end
    if (_T_72) begin
      if (_T_25) begin
        tbl_1 <= tbl_2;
      end else begin
        if (_T_69) begin
          if (_T_22) begin
            tbl_1 <= tbl_0;
          end else begin
            if (_T_60) begin
              if (_T_25) begin
                tbl_1 <= tbl_2;
              end else begin
                if (_T_57) begin
                  if (_T_22) begin
                    tbl_1 <= tbl_0;
                  end else begin
                    if (_T_48) begin
                      if (_T_25) begin
                        tbl_1 <= tbl_2;
                      end else begin
                        if (_T_45) begin
                          if (_T_22) begin
                            tbl_1 <= tbl_0;
                          end else begin
                            if (_T_36) begin
                              if (_T_25) begin
                                tbl_1 <= tbl_2;
                              end else begin
                                if (_T_33) begin
                                  if (_T_22) begin
                                    tbl_1 <= tbl_0;
                                  end else begin
                                    if (_T_24) begin
                                      if (_T_25) begin
                                        tbl_1 <= tbl_2;
                                      end else begin
                                        if (_T_21) begin
                                          if (_T_22) begin
                                            tbl_1 <= tbl_0;
                                          end else begin
                                            if (io_e) begin
                                              tbl_1 <= io_x1;
                                            end
                                          end
                                        end else begin
                                          if (io_e) begin
                                            tbl_1 <= io_x1;
                                          end
                                        end
                                      end
                                    end else begin
                                      if (_T_21) begin
                                        if (_T_22) begin
                                          tbl_1 <= tbl_0;
                                        end else begin
                                          if (io_e) begin
                                            tbl_1 <= io_x1;
                                          end
                                        end
                                      end else begin
                                        if (io_e) begin
                                          tbl_1 <= io_x1;
                                        end
                                      end
                                    end
                                  end
                                end else begin
                                  if (_T_24) begin
                                    if (_T_25) begin
                                      tbl_1 <= tbl_2;
                                    end else begin
                                      if (_T_21) begin
                                        if (_T_22) begin
                                          tbl_1 <= tbl_0;
                                        end else begin
                                          tbl_1 <= _GEN_1;
                                        end
                                      end else begin
                                        tbl_1 <= _GEN_1;
                                      end
                                    end
                                  end else begin
                                    if (_T_21) begin
                                      if (_T_22) begin
                                        tbl_1 <= tbl_0;
                                      end else begin
                                        tbl_1 <= _GEN_1;
                                      end
                                    end else begin
                                      tbl_1 <= _GEN_1;
                                    end
                                  end
                                end
                              end
                            end else begin
                              if (_T_33) begin
                                if (_T_22) begin
                                  tbl_1 <= tbl_0;
                                end else begin
                                  if (_T_24) begin
                                    if (_T_25) begin
                                      tbl_1 <= tbl_2;
                                    end else begin
                                      tbl_1 <= _GEN_7;
                                    end
                                  end else begin
                                    tbl_1 <= _GEN_7;
                                  end
                                end
                              end else begin
                                if (_T_24) begin
                                  if (_T_25) begin
                                    tbl_1 <= tbl_2;
                                  end else begin
                                    tbl_1 <= _GEN_7;
                                  end
                                end else begin
                                  tbl_1 <= _GEN_7;
                                end
                              end
                            end
                          end
                        end else begin
                          if (_T_36) begin
                            if (_T_25) begin
                              tbl_1 <= tbl_2;
                            end else begin
                              if (_T_33) begin
                                if (_T_22) begin
                                  tbl_1 <= tbl_0;
                                end else begin
                                  tbl_1 <= _GEN_12;
                                end
                              end else begin
                                tbl_1 <= _GEN_12;
                              end
                            end
                          end else begin
                            if (_T_33) begin
                              if (_T_22) begin
                                tbl_1 <= tbl_0;
                              end else begin
                                tbl_1 <= _GEN_12;
                              end
                            end else begin
                              tbl_1 <= _GEN_12;
                            end
                          end
                        end
                      end
                    end else begin
                      if (_T_45) begin
                        if (_T_22) begin
                          tbl_1 <= tbl_0;
                        end else begin
                          if (_T_36) begin
                            if (_T_25) begin
                              tbl_1 <= tbl_2;
                            end else begin
                              tbl_1 <= _GEN_23;
                            end
                          end else begin
                            tbl_1 <= _GEN_23;
                          end
                        end
                      end else begin
                        if (_T_36) begin
                          if (_T_25) begin
                            tbl_1 <= tbl_2;
                          end else begin
                            tbl_1 <= _GEN_23;
                          end
                        end else begin
                          tbl_1 <= _GEN_23;
                        end
                      end
                    end
                  end
                end else begin
                  if (_T_48) begin
                    if (_T_25) begin
                      tbl_1 <= tbl_2;
                    end else begin
                      if (_T_45) begin
                        if (_T_22) begin
                          tbl_1 <= tbl_0;
                        end else begin
                          tbl_1 <= _GEN_28;
                        end
                      end else begin
                        tbl_1 <= _GEN_28;
                      end
                    end
                  end else begin
                    if (_T_45) begin
                      if (_T_22) begin
                        tbl_1 <= tbl_0;
                      end else begin
                        tbl_1 <= _GEN_28;
                      end
                    end else begin
                      tbl_1 <= _GEN_28;
                    end
                  end
                end
              end
            end else begin
              if (_T_57) begin
                if (_T_22) begin
                  tbl_1 <= tbl_0;
                end else begin
                  if (_T_48) begin
                    if (_T_25) begin
                      tbl_1 <= tbl_2;
                    end else begin
                      tbl_1 <= _GEN_39;
                    end
                  end else begin
                    tbl_1 <= _GEN_39;
                  end
                end
              end else begin
                if (_T_48) begin
                  if (_T_25) begin
                    tbl_1 <= tbl_2;
                  end else begin
                    tbl_1 <= _GEN_39;
                  end
                end else begin
                  tbl_1 <= _GEN_39;
                end
              end
            end
          end
        end else begin
          if (_T_60) begin
            if (_T_25) begin
              tbl_1 <= tbl_2;
            end else begin
              if (_T_57) begin
                if (_T_22) begin
                  tbl_1 <= tbl_0;
                end else begin
                  tbl_1 <= _GEN_44;
                end
              end else begin
                tbl_1 <= _GEN_44;
              end
            end
          end else begin
            if (_T_57) begin
              if (_T_22) begin
                tbl_1 <= tbl_0;
              end else begin
                tbl_1 <= _GEN_44;
              end
            end else begin
              tbl_1 <= _GEN_44;
            end
          end
        end
      end
    end else begin
      if (_T_69) begin
        if (_T_22) begin
          tbl_1 <= tbl_0;
        end else begin
          if (_T_60) begin
            if (_T_25) begin
              tbl_1 <= tbl_2;
            end else begin
              tbl_1 <= _GEN_55;
            end
          end else begin
            tbl_1 <= _GEN_55;
          end
        end
      end else begin
        if (_T_60) begin
          if (_T_25) begin
            tbl_1 <= tbl_2;
          end else begin
            tbl_1 <= _GEN_55;
          end
        end else begin
          tbl_1 <= _GEN_55;
        end
      end
    end
    if (_T_75) begin
      if (_T_28) begin
        tbl_2 <= tbl_3;
      end else begin
        if (_T_72) begin
          if (_T_25) begin
            tbl_2 <= tbl_1;
          end else begin
            if (_T_63) begin
              if (_T_28) begin
                tbl_2 <= tbl_3;
              end else begin
                if (_T_60) begin
                  if (_T_25) begin
                    tbl_2 <= tbl_1;
                  end else begin
                    if (_T_51) begin
                      if (_T_28) begin
                        tbl_2 <= tbl_3;
                      end else begin
                        if (_T_48) begin
                          if (_T_25) begin
                            tbl_2 <= tbl_1;
                          end else begin
                            if (_T_39) begin
                              if (_T_28) begin
                                tbl_2 <= tbl_3;
                              end else begin
                                if (_T_36) begin
                                  if (_T_25) begin
                                    tbl_2 <= tbl_1;
                                  end else begin
                                    if (_T_27) begin
                                      if (_T_28) begin
                                        tbl_2 <= tbl_3;
                                      end else begin
                                        if (_T_24) begin
                                          if (_T_25) begin
                                            tbl_2 <= tbl_1;
                                          end else begin
                                            if (io_e) begin
                                              tbl_2 <= io_x2;
                                            end
                                          end
                                        end else begin
                                          if (io_e) begin
                                            tbl_2 <= io_x2;
                                          end
                                        end
                                      end
                                    end else begin
                                      if (_T_24) begin
                                        if (_T_25) begin
                                          tbl_2 <= tbl_1;
                                        end else begin
                                          if (io_e) begin
                                            tbl_2 <= io_x2;
                                          end
                                        end
                                      end else begin
                                        if (io_e) begin
                                          tbl_2 <= io_x2;
                                        end
                                      end
                                    end
                                  end
                                end else begin
                                  if (_T_27) begin
                                    if (_T_28) begin
                                      tbl_2 <= tbl_3;
                                    end else begin
                                      if (_T_24) begin
                                        if (_T_25) begin
                                          tbl_2 <= tbl_1;
                                        end else begin
                                          tbl_2 <= _GEN_2;
                                        end
                                      end else begin
                                        tbl_2 <= _GEN_2;
                                      end
                                    end
                                  end else begin
                                    if (_T_24) begin
                                      if (_T_25) begin
                                        tbl_2 <= tbl_1;
                                      end else begin
                                        tbl_2 <= _GEN_2;
                                      end
                                    end else begin
                                      tbl_2 <= _GEN_2;
                                    end
                                  end
                                end
                              end
                            end else begin
                              if (_T_36) begin
                                if (_T_25) begin
                                  tbl_2 <= tbl_1;
                                end else begin
                                  if (_T_27) begin
                                    if (_T_28) begin
                                      tbl_2 <= tbl_3;
                                    end else begin
                                      tbl_2 <= _GEN_11;
                                    end
                                  end else begin
                                    tbl_2 <= _GEN_11;
                                  end
                                end
                              end else begin
                                if (_T_27) begin
                                  if (_T_28) begin
                                    tbl_2 <= tbl_3;
                                  end else begin
                                    tbl_2 <= _GEN_11;
                                  end
                                end else begin
                                  tbl_2 <= _GEN_11;
                                end
                              end
                            end
                          end
                        end else begin
                          if (_T_39) begin
                            if (_T_28) begin
                              tbl_2 <= tbl_3;
                            end else begin
                              if (_T_36) begin
                                if (_T_25) begin
                                  tbl_2 <= tbl_1;
                                end else begin
                                  tbl_2 <= _GEN_16;
                                end
                              end else begin
                                tbl_2 <= _GEN_16;
                              end
                            end
                          end else begin
                            if (_T_36) begin
                              if (_T_25) begin
                                tbl_2 <= tbl_1;
                              end else begin
                                tbl_2 <= _GEN_16;
                              end
                            end else begin
                              tbl_2 <= _GEN_16;
                            end
                          end
                        end
                      end
                    end else begin
                      if (_T_48) begin
                        if (_T_25) begin
                          tbl_2 <= tbl_1;
                        end else begin
                          if (_T_39) begin
                            if (_T_28) begin
                              tbl_2 <= tbl_3;
                            end else begin
                              tbl_2 <= _GEN_27;
                            end
                          end else begin
                            tbl_2 <= _GEN_27;
                          end
                        end
                      end else begin
                        if (_T_39) begin
                          if (_T_28) begin
                            tbl_2 <= tbl_3;
                          end else begin
                            tbl_2 <= _GEN_27;
                          end
                        end else begin
                          tbl_2 <= _GEN_27;
                        end
                      end
                    end
                  end
                end else begin
                  if (_T_51) begin
                    if (_T_28) begin
                      tbl_2 <= tbl_3;
                    end else begin
                      if (_T_48) begin
                        if (_T_25) begin
                          tbl_2 <= tbl_1;
                        end else begin
                          tbl_2 <= _GEN_32;
                        end
                      end else begin
                        tbl_2 <= _GEN_32;
                      end
                    end
                  end else begin
                    if (_T_48) begin
                      if (_T_25) begin
                        tbl_2 <= tbl_1;
                      end else begin
                        tbl_2 <= _GEN_32;
                      end
                    end else begin
                      tbl_2 <= _GEN_32;
                    end
                  end
                end
              end
            end else begin
              if (_T_60) begin
                if (_T_25) begin
                  tbl_2 <= tbl_1;
                end else begin
                  if (_T_51) begin
                    if (_T_28) begin
                      tbl_2 <= tbl_3;
                    end else begin
                      tbl_2 <= _GEN_43;
                    end
                  end else begin
                    tbl_2 <= _GEN_43;
                  end
                end
              end else begin
                if (_T_51) begin
                  if (_T_28) begin
                    tbl_2 <= tbl_3;
                  end else begin
                    tbl_2 <= _GEN_43;
                  end
                end else begin
                  tbl_2 <= _GEN_43;
                end
              end
            end
          end
        end else begin
          if (_T_63) begin
            if (_T_28) begin
              tbl_2 <= tbl_3;
            end else begin
              if (_T_60) begin
                if (_T_25) begin
                  tbl_2 <= tbl_1;
                end else begin
                  tbl_2 <= _GEN_48;
                end
              end else begin
                tbl_2 <= _GEN_48;
              end
            end
          end else begin
            if (_T_60) begin
              if (_T_25) begin
                tbl_2 <= tbl_1;
              end else begin
                tbl_2 <= _GEN_48;
              end
            end else begin
              tbl_2 <= _GEN_48;
            end
          end
        end
      end
    end else begin
      if (_T_72) begin
        if (_T_25) begin
          tbl_2 <= tbl_1;
        end else begin
          if (_T_63) begin
            if (_T_28) begin
              tbl_2 <= tbl_3;
            end else begin
              tbl_2 <= _GEN_59;
            end
          end else begin
            tbl_2 <= _GEN_59;
          end
        end
      end else begin
        if (_T_63) begin
          if (_T_28) begin
            tbl_2 <= tbl_3;
          end else begin
            tbl_2 <= _GEN_59;
          end
        end else begin
          tbl_2 <= _GEN_59;
        end
      end
    end
    if (_T_78) begin
      if (_T_31) begin
        tbl_3 <= tbl_4;
      end else begin
        if (_T_75) begin
          if (_T_28) begin
            tbl_3 <= tbl_2;
          end else begin
            if (_T_66) begin
              if (_T_31) begin
                tbl_3 <= tbl_4;
              end else begin
                if (_T_63) begin
                  if (_T_28) begin
                    tbl_3 <= tbl_2;
                  end else begin
                    if (_T_54) begin
                      if (_T_31) begin
                        tbl_3 <= tbl_4;
                      end else begin
                        if (_T_51) begin
                          if (_T_28) begin
                            tbl_3 <= tbl_2;
                          end else begin
                            if (_T_42) begin
                              if (_T_31) begin
                                tbl_3 <= tbl_4;
                              end else begin
                                if (_T_39) begin
                                  if (_T_28) begin
                                    tbl_3 <= tbl_2;
                                  end else begin
                                    if (_T_30) begin
                                      if (_T_31) begin
                                        tbl_3 <= tbl_4;
                                      end else begin
                                        if (_T_27) begin
                                          if (_T_28) begin
                                            tbl_3 <= tbl_2;
                                          end else begin
                                            if (io_e) begin
                                              tbl_3 <= io_x3;
                                            end
                                          end
                                        end else begin
                                          if (io_e) begin
                                            tbl_3 <= io_x3;
                                          end
                                        end
                                      end
                                    end else begin
                                      if (_T_27) begin
                                        if (_T_28) begin
                                          tbl_3 <= tbl_2;
                                        end else begin
                                          if (io_e) begin
                                            tbl_3 <= io_x3;
                                          end
                                        end
                                      end else begin
                                        if (io_e) begin
                                          tbl_3 <= io_x3;
                                        end
                                      end
                                    end
                                  end
                                end else begin
                                  if (_T_30) begin
                                    if (_T_31) begin
                                      tbl_3 <= tbl_4;
                                    end else begin
                                      if (_T_27) begin
                                        if (_T_28) begin
                                          tbl_3 <= tbl_2;
                                        end else begin
                                          tbl_3 <= _GEN_3;
                                        end
                                      end else begin
                                        tbl_3 <= _GEN_3;
                                      end
                                    end
                                  end else begin
                                    if (_T_27) begin
                                      if (_T_28) begin
                                        tbl_3 <= tbl_2;
                                      end else begin
                                        tbl_3 <= _GEN_3;
                                      end
                                    end else begin
                                      tbl_3 <= _GEN_3;
                                    end
                                  end
                                end
                              end
                            end else begin
                              if (_T_39) begin
                                if (_T_28) begin
                                  tbl_3 <= tbl_2;
                                end else begin
                                  if (_T_30) begin
                                    if (_T_31) begin
                                      tbl_3 <= tbl_4;
                                    end else begin
                                      tbl_3 <= _GEN_15;
                                    end
                                  end else begin
                                    tbl_3 <= _GEN_15;
                                  end
                                end
                              end else begin
                                if (_T_30) begin
                                  if (_T_31) begin
                                    tbl_3 <= tbl_4;
                                  end else begin
                                    tbl_3 <= _GEN_15;
                                  end
                                end else begin
                                  tbl_3 <= _GEN_15;
                                end
                              end
                            end
                          end
                        end else begin
                          if (_T_42) begin
                            if (_T_31) begin
                              tbl_3 <= tbl_4;
                            end else begin
                              if (_T_39) begin
                                if (_T_28) begin
                                  tbl_3 <= tbl_2;
                                end else begin
                                  tbl_3 <= _GEN_20;
                                end
                              end else begin
                                tbl_3 <= _GEN_20;
                              end
                            end
                          end else begin
                            if (_T_39) begin
                              if (_T_28) begin
                                tbl_3 <= tbl_2;
                              end else begin
                                tbl_3 <= _GEN_20;
                              end
                            end else begin
                              tbl_3 <= _GEN_20;
                            end
                          end
                        end
                      end
                    end else begin
                      if (_T_51) begin
                        if (_T_28) begin
                          tbl_3 <= tbl_2;
                        end else begin
                          if (_T_42) begin
                            if (_T_31) begin
                              tbl_3 <= tbl_4;
                            end else begin
                              tbl_3 <= _GEN_31;
                            end
                          end else begin
                            tbl_3 <= _GEN_31;
                          end
                        end
                      end else begin
                        if (_T_42) begin
                          if (_T_31) begin
                            tbl_3 <= tbl_4;
                          end else begin
                            tbl_3 <= _GEN_31;
                          end
                        end else begin
                          tbl_3 <= _GEN_31;
                        end
                      end
                    end
                  end
                end else begin
                  if (_T_54) begin
                    if (_T_31) begin
                      tbl_3 <= tbl_4;
                    end else begin
                      if (_T_51) begin
                        if (_T_28) begin
                          tbl_3 <= tbl_2;
                        end else begin
                          tbl_3 <= _GEN_36;
                        end
                      end else begin
                        tbl_3 <= _GEN_36;
                      end
                    end
                  end else begin
                    if (_T_51) begin
                      if (_T_28) begin
                        tbl_3 <= tbl_2;
                      end else begin
                        tbl_3 <= _GEN_36;
                      end
                    end else begin
                      tbl_3 <= _GEN_36;
                    end
                  end
                end
              end
            end else begin
              if (_T_63) begin
                if (_T_28) begin
                  tbl_3 <= tbl_2;
                end else begin
                  if (_T_54) begin
                    if (_T_31) begin
                      tbl_3 <= tbl_4;
                    end else begin
                      tbl_3 <= _GEN_47;
                    end
                  end else begin
                    tbl_3 <= _GEN_47;
                  end
                end
              end else begin
                if (_T_54) begin
                  if (_T_31) begin
                    tbl_3 <= tbl_4;
                  end else begin
                    tbl_3 <= _GEN_47;
                  end
                end else begin
                  tbl_3 <= _GEN_47;
                end
              end
            end
          end
        end else begin
          if (_T_66) begin
            if (_T_31) begin
              tbl_3 <= tbl_4;
            end else begin
              if (_T_63) begin
                if (_T_28) begin
                  tbl_3 <= tbl_2;
                end else begin
                  tbl_3 <= _GEN_52;
                end
              end else begin
                tbl_3 <= _GEN_52;
              end
            end
          end else begin
            if (_T_63) begin
              if (_T_28) begin
                tbl_3 <= tbl_2;
              end else begin
                tbl_3 <= _GEN_52;
              end
            end else begin
              tbl_3 <= _GEN_52;
            end
          end
        end
      end
    end else begin
      if (_T_75) begin
        if (_T_28) begin
          tbl_3 <= tbl_2;
        end else begin
          if (_T_66) begin
            if (_T_31) begin
              tbl_3 <= tbl_4;
            end else begin
              tbl_3 <= _GEN_63;
            end
          end else begin
            tbl_3 <= _GEN_63;
          end
        end
      end else begin
        if (_T_66) begin
          if (_T_31) begin
            tbl_3 <= tbl_4;
          end else begin
            tbl_3 <= _GEN_63;
          end
        end else begin
          tbl_3 <= _GEN_63;
        end
      end
    end
    if (_T_78) begin
      if (_T_31) begin
        tbl_4 <= tbl_3;
      end else begin
        if (_T_66) begin
          if (_T_31) begin
            tbl_4 <= tbl_3;
          end else begin
            if (_T_54) begin
              if (_T_31) begin
                tbl_4 <= tbl_3;
              end else begin
                if (_T_42) begin
                  if (_T_31) begin
                    tbl_4 <= tbl_3;
                  end else begin
                    if (_T_30) begin
                      if (_T_31) begin
                        tbl_4 <= tbl_3;
                      end else begin
                        if (io_e) begin
                          tbl_4 <= io_x4;
                        end
                      end
                    end else begin
                      if (io_e) begin
                        tbl_4 <= io_x4;
                      end
                    end
                  end
                end else begin
                  if (_T_30) begin
                    if (_T_31) begin
                      tbl_4 <= tbl_3;
                    end else begin
                      if (io_e) begin
                        tbl_4 <= io_x4;
                      end
                    end
                  end else begin
                    if (io_e) begin
                      tbl_4 <= io_x4;
                    end
                  end
                end
              end
            end else begin
              if (_T_42) begin
                if (_T_31) begin
                  tbl_4 <= tbl_3;
                end else begin
                  if (_T_30) begin
                    if (_T_31) begin
                      tbl_4 <= tbl_3;
                    end else begin
                      tbl_4 <= _GEN_4;
                    end
                  end else begin
                    tbl_4 <= _GEN_4;
                  end
                end
              end else begin
                if (_T_30) begin
                  if (_T_31) begin
                    tbl_4 <= tbl_3;
                  end else begin
                    tbl_4 <= _GEN_4;
                  end
                end else begin
                  tbl_4 <= _GEN_4;
                end
              end
            end
          end
        end else begin
          if (_T_54) begin
            if (_T_31) begin
              tbl_4 <= tbl_3;
            end else begin
              if (_T_42) begin
                if (_T_31) begin
                  tbl_4 <= tbl_3;
                end else begin
                  tbl_4 <= _GEN_19;
                end
              end else begin
                tbl_4 <= _GEN_19;
              end
            end
          end else begin
            if (_T_42) begin
              if (_T_31) begin
                tbl_4 <= tbl_3;
              end else begin
                tbl_4 <= _GEN_19;
              end
            end else begin
              tbl_4 <= _GEN_19;
            end
          end
        end
      end
    end else begin
      if (_T_66) begin
        if (_T_31) begin
          tbl_4 <= tbl_3;
        end else begin
          if (_T_54) begin
            if (_T_31) begin
              tbl_4 <= tbl_3;
            end else begin
              tbl_4 <= _GEN_35;
            end
          end else begin
            tbl_4 <= _GEN_35;
          end
        end
      end else begin
        if (_T_54) begin
          if (_T_31) begin
            tbl_4 <= tbl_3;
          end else begin
            tbl_4 <= _GEN_35;
          end
        end else begin
          tbl_4 <= _GEN_35;
        end
      end
    end
  end
endmodule
module median3(
  input        clock,
  input  [7:0] io_x0,
  input  [7:0] io_x1,
  input  [7:0] io_x2,
  input  [4:0] io_cnt,
  input  [4:0] io_cnt_1,
  output [7:0] io_z
);
  reg [7:0] tbl_0;
  reg [31:0] _RAND_0;
  reg [7:0] tbl_1;
  reg [31:0] _RAND_1;
  reg [7:0] tbl_2;
  reg [31:0] _RAND_2;
  wire  _T_17;
  wire [7:0] _GEN_0;
  wire [7:0] _GEN_1;
  wire [7:0] _GEN_2;
  wire  _T_19;
  wire  _T_20;
  wire [7:0] _GEN_3;
  wire [7:0] _GEN_4;
  wire [7:0] _GEN_5;
  wire [7:0] _GEN_6;
  wire  _T_22;
  wire  _T_23;
  wire [7:0] _GEN_7;
  wire [7:0] _GEN_8;
  wire [7:0] _GEN_9;
  wire [7:0] _GEN_10;
  wire  _T_25;
  wire [7:0] _GEN_11;
  wire [7:0] _GEN_12;
  wire [7:0] _GEN_13;
  wire [7:0] _GEN_14;
  wire  _T_28;
  wire [7:0] _GEN_15;
  wire [7:0] _GEN_16;
  wire [7:0] _GEN_17;
  wire [7:0] _GEN_18;
  wire  _T_31;
  wire [7:0] _GEN_19;
  wire [7:0] _GEN_20;
  wire [7:0] _GEN_21;
  wire [7:0] _GEN_22;
  wire  _T_34;
  wire [7:0] _GEN_23;
  wire [7:0] _GEN_24;
  wire [7:0] _GEN_25;
  wire [7:0] _GEN_26;
  assign _T_17 = io_cnt == 5'hf;
  assign _GEN_0 = _T_17 ? io_x0 : tbl_0;
  assign _GEN_1 = _T_17 ? io_x1 : tbl_1;
  assign _GEN_2 = _T_17 ? io_x2 : tbl_2;
  assign _T_19 = io_cnt_1 == 5'h1;
  assign _T_20 = tbl_1 < tbl_0;
  assign _GEN_3 = _T_20 ? tbl_0 : _GEN_1;
  assign _GEN_4 = _T_20 ? tbl_1 : _GEN_0;
  assign _GEN_5 = _T_19 ? _GEN_3 : _GEN_1;
  assign _GEN_6 = _T_19 ? _GEN_4 : _GEN_0;
  assign _T_22 = io_cnt_1 == 5'h2;
  assign _T_23 = tbl_2 < tbl_1;
  assign _GEN_7 = _T_23 ? tbl_1 : _GEN_2;
  assign _GEN_8 = _T_23 ? tbl_2 : _GEN_5;
  assign _GEN_9 = _T_22 ? _GEN_7 : _GEN_2;
  assign _GEN_10 = _T_22 ? _GEN_8 : _GEN_5;
  assign _T_25 = io_cnt_1 == 5'h3;
  assign _GEN_11 = _T_20 ? tbl_0 : _GEN_10;
  assign _GEN_12 = _T_20 ? tbl_1 : _GEN_6;
  assign _GEN_13 = _T_25 ? _GEN_11 : _GEN_10;
  assign _GEN_14 = _T_25 ? _GEN_12 : _GEN_6;
  assign _T_28 = io_cnt_1 == 5'h4;
  assign _GEN_15 = _T_23 ? tbl_1 : _GEN_9;
  assign _GEN_16 = _T_23 ? tbl_2 : _GEN_13;
  assign _GEN_17 = _T_28 ? _GEN_15 : _GEN_9;
  assign _GEN_18 = _T_28 ? _GEN_16 : _GEN_13;
  assign _T_31 = io_cnt_1 == 5'h5;
  assign _GEN_19 = _T_20 ? tbl_0 : _GEN_18;
  assign _GEN_20 = _T_20 ? tbl_1 : _GEN_14;
  assign _GEN_21 = _T_31 ? _GEN_19 : _GEN_18;
  assign _GEN_22 = _T_31 ? _GEN_20 : _GEN_14;
  assign _T_34 = io_cnt_1 == 5'h6;
  assign _GEN_23 = _T_23 ? tbl_1 : _GEN_17;
  assign _GEN_24 = _T_23 ? tbl_2 : _GEN_21;
  assign _GEN_25 = _T_34 ? _GEN_23 : _GEN_17;
  assign _GEN_26 = _T_34 ? _GEN_24 : _GEN_21;
  assign io_z = tbl_1;
`ifdef RANDOMIZE
  integer initvar;
  initial begin
    `ifndef verilator
      #0.002 begin end
    `endif
  `ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{$random}};
  tbl_0 = _RAND_0[7:0];
  `endif // RANDOMIZE_REG_INIT
  `ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{$random}};
  tbl_1 = _RAND_1[7:0];
  `endif // RANDOMIZE_REG_INIT
  `ifdef RANDOMIZE_REG_INIT
  _RAND_2 = {1{$random}};
  tbl_2 = _RAND_2[7:0];
  `endif // RANDOMIZE_REG_INIT
  end
`endif // RANDOMIZE
  always @(posedge clock) begin
    if (_T_31) begin
      if (_T_20) begin
        tbl_0 <= tbl_1;
      end else begin
        if (_T_25) begin
          if (_T_20) begin
            tbl_0 <= tbl_1;
          end else begin
            if (_T_19) begin
              if (_T_20) begin
                tbl_0 <= tbl_1;
              end else begin
                if (_T_17) begin
                  tbl_0 <= io_x0;
                end
              end
            end else begin
              if (_T_17) begin
                tbl_0 <= io_x0;
              end
            end
          end
        end else begin
          if (_T_19) begin
            if (_T_20) begin
              tbl_0 <= tbl_1;
            end else begin
              if (_T_17) begin
                tbl_0 <= io_x0;
              end
            end
          end else begin
            if (_T_17) begin
              tbl_0 <= io_x0;
            end
          end
        end
      end
    end else begin
      if (_T_25) begin
        if (_T_20) begin
          tbl_0 <= tbl_1;
        end else begin
          if (_T_19) begin
            if (_T_20) begin
              tbl_0 <= tbl_1;
            end else begin
              tbl_0 <= _GEN_0;
            end
          end else begin
            tbl_0 <= _GEN_0;
          end
        end
      end else begin
        if (_T_19) begin
          if (_T_20) begin
            tbl_0 <= tbl_1;
          end else begin
            tbl_0 <= _GEN_0;
          end
        end else begin
          tbl_0 <= _GEN_0;
        end
      end
    end
    if (_T_34) begin
      if (_T_23) begin
        tbl_1 <= tbl_2;
      end else begin
        if (_T_31) begin
          if (_T_20) begin
            tbl_1 <= tbl_0;
          end else begin
            if (_T_28) begin
              if (_T_23) begin
                tbl_1 <= tbl_2;
              end else begin
                if (_T_25) begin
                  if (_T_20) begin
                    tbl_1 <= tbl_0;
                  end else begin
                    if (_T_22) begin
                      if (_T_23) begin
                        tbl_1 <= tbl_2;
                      end else begin
                        if (_T_19) begin
                          if (_T_20) begin
                            tbl_1 <= tbl_0;
                          end else begin
                            if (_T_17) begin
                              tbl_1 <= io_x1;
                            end
                          end
                        end else begin
                          if (_T_17) begin
                            tbl_1 <= io_x1;
                          end
                        end
                      end
                    end else begin
                      if (_T_19) begin
                        if (_T_20) begin
                          tbl_1 <= tbl_0;
                        end else begin
                          if (_T_17) begin
                            tbl_1 <= io_x1;
                          end
                        end
                      end else begin
                        if (_T_17) begin
                          tbl_1 <= io_x1;
                        end
                      end
                    end
                  end
                end else begin
                  if (_T_22) begin
                    if (_T_23) begin
                      tbl_1 <= tbl_2;
                    end else begin
                      if (_T_19) begin
                        if (_T_20) begin
                          tbl_1 <= tbl_0;
                        end else begin
                          tbl_1 <= _GEN_1;
                        end
                      end else begin
                        tbl_1 <= _GEN_1;
                      end
                    end
                  end else begin
                    if (_T_19) begin
                      if (_T_20) begin
                        tbl_1 <= tbl_0;
                      end else begin
                        tbl_1 <= _GEN_1;
                      end
                    end else begin
                      tbl_1 <= _GEN_1;
                    end
                  end
                end
              end
            end else begin
              if (_T_25) begin
                if (_T_20) begin
                  tbl_1 <= tbl_0;
                end else begin
                  if (_T_22) begin
                    if (_T_23) begin
                      tbl_1 <= tbl_2;
                    end else begin
                      tbl_1 <= _GEN_5;
                    end
                  end else begin
                    tbl_1 <= _GEN_5;
                  end
                end
              end else begin
                if (_T_22) begin
                  if (_T_23) begin
                    tbl_1 <= tbl_2;
                  end else begin
                    tbl_1 <= _GEN_5;
                  end
                end else begin
                  tbl_1 <= _GEN_5;
                end
              end
            end
          end
        end else begin
          if (_T_28) begin
            if (_T_23) begin
              tbl_1 <= tbl_2;
            end else begin
              if (_T_25) begin
                if (_T_20) begin
                  tbl_1 <= tbl_0;
                end else begin
                  tbl_1 <= _GEN_10;
                end
              end else begin
                tbl_1 <= _GEN_10;
              end
            end
          end else begin
            if (_T_25) begin
              if (_T_20) begin
                tbl_1 <= tbl_0;
              end else begin
                tbl_1 <= _GEN_10;
              end
            end else begin
              tbl_1 <= _GEN_10;
            end
          end
        end
      end
    end else begin
      if (_T_31) begin
        if (_T_20) begin
          tbl_1 <= tbl_0;
        end else begin
          if (_T_28) begin
            if (_T_23) begin
              tbl_1 <= tbl_2;
            end else begin
              tbl_1 <= _GEN_13;
            end
          end else begin
            tbl_1 <= _GEN_13;
          end
        end
      end else begin
        if (_T_28) begin
          if (_T_23) begin
            tbl_1 <= tbl_2;
          end else begin
            tbl_1 <= _GEN_13;
          end
        end else begin
          tbl_1 <= _GEN_13;
        end
      end
    end
    if (_T_34) begin
      if (_T_23) begin
        tbl_2 <= tbl_1;
      end else begin
        if (_T_28) begin
          if (_T_23) begin
            tbl_2 <= tbl_1;
          end else begin
            if (_T_22) begin
              if (_T_23) begin
                tbl_2 <= tbl_1;
              end else begin
                if (_T_17) begin
                  tbl_2 <= io_x2;
                end
              end
            end else begin
              if (_T_17) begin
                tbl_2 <= io_x2;
              end
            end
          end
        end else begin
          if (_T_22) begin
            if (_T_23) begin
              tbl_2 <= tbl_1;
            end else begin
              if (_T_17) begin
                tbl_2 <= io_x2;
              end
            end
          end else begin
            if (_T_17) begin
              tbl_2 <= io_x2;
            end
          end
        end
      end
    end else begin
      if (_T_28) begin
        if (_T_23) begin
          tbl_2 <= tbl_1;
        end else begin
          if (_T_22) begin
            if (_T_23) begin
              tbl_2 <= tbl_1;
            end else begin
              tbl_2 <= _GEN_2;
            end
          end else begin
            tbl_2 <= _GEN_2;
          end
        end
      end else begin
        if (_T_22) begin
          if (_T_23) begin
            tbl_2 <= tbl_1;
          end else begin
            tbl_2 <= _GEN_2;
          end
        end else begin
          tbl_2 <= _GEN_2;
        end
      end
    end
  end
endmodule
module hybrid(
  input        clock,
  input        reset,
  input  [7:0] io_R0,
  input  [7:0] io_R1,
  input  [7:0] io_R2,
  input  [7:0] io_R3,
  input  [7:0] io_R4,
  input  [7:0] io_R5,
  input  [7:0] io_R6,
  input  [7:0] io_R7,
  input  [7:0] io_R8,
  input  [7:0] io_G0,
  input  [7:0] io_G1,
  input  [7:0] io_G2,
  input  [7:0] io_G3,
  input  [7:0] io_G4,
  input  [7:0] io_G5,
  input  [7:0] io_G6,
  input  [7:0] io_G7,
  input  [7:0] io_G8,
  input  [7:0] io_B0,
  input  [7:0] io_B1,
  input  [7:0] io_B2,
  input  [7:0] io_B3,
  input  [7:0] io_B4,
  input  [7:0] io_B5,
  input  [7:0] io_B6,
  input  [7:0] io_B7,
  input  [7:0] io_B8,
  input        io_e,
  output [7:0] io_ansR,
  output [7:0] io_ansG,
  output [7:0] io_ansB
);
  reg [4:0] cnt;
  reg [31:0] _RAND_0;
  wire  _T_36;
  wire [5:0] _T_38;
  wire [4:0] _T_39;
  wire [4:0] _GEN_0;
  wire [4:0] _GEN_1;
  reg [4:0] cnt_1;
  reg [31:0] _RAND_1;
  wire  _T_44;
  wire [5:0] _T_46;
  wire [4:0] _T_47;
  wire  _T_49;
  wire  _T_50;
  wire  _T_53;
  wire [4:0] _GEN_2;
  wire [4:0] _GEN_3;
  wire [4:0] _GEN_4;
  wire  R_0_clock;
  wire [7:0] R_0_io_x0;
  wire [7:0] R_0_io_x1;
  wire [7:0] R_0_io_x2;
  wire [7:0] R_0_io_x3;
  wire [7:0] R_0_io_x4;
  wire [4:0] R_0_io_cnt;
  wire  R_0_io_e;
  wire [7:0] R_0_io_z;
  wire  R_1_clock;
  wire [7:0] R_1_io_x0;
  wire [7:0] R_1_io_x1;
  wire [7:0] R_1_io_x2;
  wire [7:0] R_1_io_x3;
  wire [7:0] R_1_io_x4;
  wire [4:0] R_1_io_cnt;
  wire  R_1_io_e;
  wire [7:0] R_1_io_z;
  wire  R_2_clock;
  wire [7:0] R_2_io_x0;
  wire [7:0] R_2_io_x1;
  wire [7:0] R_2_io_x2;
  wire [4:0] R_2_io_cnt;
  wire [4:0] R_2_io_cnt_1;
  wire [7:0] R_2_io_z;
  wire  G_0_clock;
  wire [7:0] G_0_io_x0;
  wire [7:0] G_0_io_x1;
  wire [7:0] G_0_io_x2;
  wire [7:0] G_0_io_x3;
  wire [7:0] G_0_io_x4;
  wire [4:0] G_0_io_cnt;
  wire  G_0_io_e;
  wire [7:0] G_0_io_z;
  wire  G_1_clock;
  wire [7:0] G_1_io_x0;
  wire [7:0] G_1_io_x1;
  wire [7:0] G_1_io_x2;
  wire [7:0] G_1_io_x3;
  wire [7:0] G_1_io_x4;
  wire [4:0] G_1_io_cnt;
  wire  G_1_io_e;
  wire [7:0] G_1_io_z;
  wire  G_2_clock;
  wire [7:0] G_2_io_x0;
  wire [7:0] G_2_io_x1;
  wire [7:0] G_2_io_x2;
  wire [4:0] G_2_io_cnt;
  wire [4:0] G_2_io_cnt_1;
  wire [7:0] G_2_io_z;
  wire  B_0_clock;
  wire [7:0] B_0_io_x0;
  wire [7:0] B_0_io_x1;
  wire [7:0] B_0_io_x2;
  wire [7:0] B_0_io_x3;
  wire [7:0] B_0_io_x4;
  wire [4:0] B_0_io_cnt;
  wire  B_0_io_e;
  wire [7:0] B_0_io_z;
  wire  B_1_clock;
  wire [7:0] B_1_io_x0;
  wire [7:0] B_1_io_x1;
  wire [7:0] B_1_io_x2;
  wire [7:0] B_1_io_x3;
  wire [7:0] B_1_io_x4;
  wire [4:0] B_1_io_cnt;
  wire  B_1_io_e;
  wire [7:0] B_1_io_z;
  wire  B_2_clock;
  wire [7:0] B_2_io_x0;
  wire [7:0] B_2_io_x1;
  wire [7:0] B_2_io_x2;
  wire [4:0] B_2_io_cnt;
  wire [4:0] B_2_io_cnt_1;
  wire [7:0] B_2_io_z;
  median5 R_0 (
    .clock(R_0_clock),
    .io_x0(R_0_io_x0),
    .io_x1(R_0_io_x1),
    .io_x2(R_0_io_x2),
    .io_x3(R_0_io_x3),
    .io_x4(R_0_io_x4),
    .io_cnt(R_0_io_cnt),
    .io_e(R_0_io_e),
    .io_z(R_0_io_z)
  );
  median5 R_1 (
    .clock(R_1_clock),
    .io_x0(R_1_io_x0),
    .io_x1(R_1_io_x1),
    .io_x2(R_1_io_x2),
    .io_x3(R_1_io_x3),
    .io_x4(R_1_io_x4),
    .io_cnt(R_1_io_cnt),
    .io_e(R_1_io_e),
    .io_z(R_1_io_z)
  );
  median3 R_2 (
    .clock(R_2_clock),
    .io_x0(R_2_io_x0),
    .io_x1(R_2_io_x1),
    .io_x2(R_2_io_x2),
    .io_cnt(R_2_io_cnt),
    .io_cnt_1(R_2_io_cnt_1),
    .io_z(R_2_io_z)
  );
  median5 G_0 (
    .clock(G_0_clock),
    .io_x0(G_0_io_x0),
    .io_x1(G_0_io_x1),
    .io_x2(G_0_io_x2),
    .io_x3(G_0_io_x3),
    .io_x4(G_0_io_x4),
    .io_cnt(G_0_io_cnt),
    .io_e(G_0_io_e),
    .io_z(G_0_io_z)
  );
  median5 G_1 (
    .clock(G_1_clock),
    .io_x0(G_1_io_x0),
    .io_x1(G_1_io_x1),
    .io_x2(G_1_io_x2),
    .io_x3(G_1_io_x3),
    .io_x4(G_1_io_x4),
    .io_cnt(G_1_io_cnt),
    .io_e(G_1_io_e),
    .io_z(G_1_io_z)
  );
  median3 G_2 (
    .clock(G_2_clock),
    .io_x0(G_2_io_x0),
    .io_x1(G_2_io_x1),
    .io_x2(G_2_io_x2),
    .io_cnt(G_2_io_cnt),
    .io_cnt_1(G_2_io_cnt_1),
    .io_z(G_2_io_z)
  );
  median5 B_0 (
    .clock(B_0_clock),
    .io_x0(B_0_io_x0),
    .io_x1(B_0_io_x1),
    .io_x2(B_0_io_x2),
    .io_x3(B_0_io_x3),
    .io_x4(B_0_io_x4),
    .io_cnt(B_0_io_cnt),
    .io_e(B_0_io_e),
    .io_z(B_0_io_z)
  );
  median5 B_1 (
    .clock(B_1_clock),
    .io_x0(B_1_io_x0),
    .io_x1(B_1_io_x1),
    .io_x2(B_1_io_x2),
    .io_x3(B_1_io_x3),
    .io_x4(B_1_io_x4),
    .io_cnt(B_1_io_cnt),
    .io_e(B_1_io_e),
    .io_z(B_1_io_z)
  );
  median3 B_2 (
    .clock(B_2_clock),
    .io_x0(B_2_io_x0),
    .io_x1(B_2_io_x1),
    .io_x2(B_2_io_x2),
    .io_cnt(B_2_io_cnt),
    .io_cnt_1(B_2_io_cnt_1),
    .io_z(B_2_io_z)
  );
  assign _T_36 = cnt < 5'h10;
  assign _T_38 = cnt + 5'h1;
  assign _T_39 = _T_38[4:0];
  assign _GEN_0 = io_e ? 5'h1 : cnt;
  assign _GEN_1 = _T_36 ? _T_39 : _GEN_0;
  assign _T_44 = cnt == 5'hf;
  assign _T_46 = cnt_1 + 5'h1;
  assign _T_47 = _T_46[4:0];
  assign _T_49 = cnt_1 == 5'h6;
  assign _T_50 = io_e | _T_49;
  assign _T_53 = cnt_1 > 5'h1;
  assign _GEN_2 = _T_53 ? _T_47 : cnt_1;
  assign _GEN_3 = _T_50 ? 5'h1 : _GEN_2;
  assign _GEN_4 = _T_44 ? _T_47 : _GEN_3;
  assign io_ansR = R_2_io_z;
  assign io_ansG = G_2_io_z;
  assign io_ansB = B_2_io_z;
  assign R_0_io_x0 = io_R1;
  assign R_0_io_x1 = io_R3;
  assign R_0_io_x2 = io_R4;
  assign R_0_io_x3 = io_R5;
  assign R_0_io_x4 = io_R7;
  assign R_0_io_cnt = cnt;
  assign R_0_io_e = io_e;
  assign R_0_clock = clock;
  assign R_1_io_x0 = io_R0;
  assign R_1_io_x1 = io_R2;
  assign R_1_io_x2 = io_R4;
  assign R_1_io_x3 = io_R6;
  assign R_1_io_x4 = io_R8;
  assign R_1_io_cnt = cnt;
  assign R_1_io_e = io_e;
  assign R_1_clock = clock;
  assign R_2_io_x0 = R_0_io_z;
  assign R_2_io_x1 = R_1_io_z;
  assign R_2_io_x2 = io_R4;
  assign R_2_io_cnt = cnt;
  assign R_2_io_cnt_1 = cnt_1;
  assign R_2_clock = clock;
  assign G_0_io_x0 = io_G1;
  assign G_0_io_x1 = io_G3;
  assign G_0_io_x2 = io_G4;
  assign G_0_io_x3 = io_G5;
  assign G_0_io_x4 = io_G7;
  assign G_0_io_cnt = cnt;
  assign G_0_io_e = io_e;
  assign G_0_clock = clock;
  assign G_1_io_x0 = io_G0;
  assign G_1_io_x1 = io_G2;
  assign G_1_io_x2 = io_G4;
  assign G_1_io_x3 = io_G6;
  assign G_1_io_x4 = io_G8;
  assign G_1_io_cnt = cnt;
  assign G_1_io_e = io_e;
  assign G_1_clock = clock;
  assign G_2_io_x0 = G_0_io_z;
  assign G_2_io_x1 = G_1_io_z;
  assign G_2_io_x2 = io_G4;
  assign G_2_io_cnt = cnt;
  assign G_2_io_cnt_1 = cnt_1;
  assign G_2_clock = clock;
  assign B_0_io_x0 = io_B1;
  assign B_0_io_x1 = io_B3;
  assign B_0_io_x2 = io_B4;
  assign B_0_io_x3 = io_B5;
  assign B_0_io_x4 = io_B7;
  assign B_0_io_cnt = cnt;
  assign B_0_io_e = io_e;
  assign B_0_clock = clock;
  assign B_1_io_x0 = io_B0;
  assign B_1_io_x1 = io_B2;
  assign B_1_io_x2 = io_B4;
  assign B_1_io_x3 = io_B6;
  assign B_1_io_x4 = io_B8;
  assign B_1_io_cnt = cnt;
  assign B_1_io_e = io_e;
  assign B_1_clock = clock;
  assign B_2_io_x0 = B_0_io_z;
  assign B_2_io_x1 = B_1_io_z;
  assign B_2_io_x2 = io_B4;
  assign B_2_io_cnt = cnt;
  assign B_2_io_cnt_1 = cnt_1;
  assign B_2_clock = clock;
`ifdef RANDOMIZE
  integer initvar;
  initial begin
    `ifndef verilator
      #0.002 begin end
    `endif
  `ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{$random}};
  cnt = _RAND_0[4:0];
  `endif // RANDOMIZE_REG_INIT
  `ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{$random}};
  cnt_1 = _RAND_1[4:0];
  `endif // RANDOMIZE_REG_INIT
  end
`endif // RANDOMIZE
  always @(posedge clock) begin
    if (reset) begin
      cnt <= 5'h1;
    end else begin
      if (_T_36) begin
        cnt <= _T_39;
      end else begin
        if (io_e) begin
          cnt <= 5'h1;
        end
      end
    end
    if (reset) begin
      cnt_1 <= 5'h1;
    end else begin
      if (_T_44) begin
        cnt_1 <= _T_47;
      end else begin
        if (_T_50) begin
          cnt_1 <= 5'h1;
        end else begin
          if (_T_53) begin
            cnt_1 <= _T_47;
          end
        end
      end
    end
  end
endmodule
