`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif

module xor_acc(
  input        clock,
  input        reset,
  input  [7:0] io_data_0,
  input  [7:0] io_data_1,
  input  [7:0] io_data_2,
  input  [7:0] io_data_3,
  input  [7:0] io_data_4,
  input  [7:0] io_data_5,
  input  [7:0] io_data_6,
  input  [7:0] io_data_7,
  input  [7:0] io_key_0,
  input  [7:0] io_key_1,
  input  [7:0] io_key_2,
  input  [7:0] io_key_3,
  input  [7:0] io_key_4,
  input  [7:0] io_key_5,
  input  [7:0] io_key_6,
  input  [7:0] io_key_7,
  output [7:0] io_xor_0,
  output [7:0] io_xor_1,
  output [7:0] io_xor_2,
  output [7:0] io_xor_3,
  output [7:0] io_xor_4,
  output [7:0] io_xor_5,
  output [7:0] io_xor_6,
  output [7:0] io_xor_7
);
  wire [7:0] _T_26;
  wire [7:0] _T_27;
  wire [7:0] _T_28;
  wire [7:0] _T_29;
  wire [7:0] _T_30;
  wire [7:0] _T_31;
  wire [7:0] _T_32;
  wire [7:0] _T_33;
  assign _T_26 = io_data_0 ^ io_key_0;
  assign _T_27 = io_data_1 ^ io_key_1;
  assign _T_28 = io_data_2 ^ io_key_2;
  assign _T_29 = io_data_3 ^ io_key_3;
  assign _T_30 = io_data_4 ^ io_key_4;
  assign _T_31 = io_data_5 ^ io_key_5;
  assign _T_32 = io_data_6 ^ io_key_6;
  assign _T_33 = io_data_7 ^ io_key_7;
  assign io_xor_0 = _T_26;
  assign io_xor_1 = _T_27;
  assign io_xor_2 = _T_28;
  assign io_xor_3 = _T_29;
  assign io_xor_4 = _T_30;
  assign io_xor_5 = _T_31;
  assign io_xor_6 = _T_32;
  assign io_xor_7 = _T_33;
endmodule
