// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Tracing implementation internals
#include "verilated_vcd_c.h"
#include "Vsobel__Syms.h"


//======================

void Vsobel::trace (VerilatedVcdC* tfp, int, int) {
    tfp->spTrace()->addCallback (&Vsobel::traceInit, &Vsobel::traceFull, &Vsobel::traceChg, this);
}
void Vsobel::traceInit(VerilatedVcd* vcdp, void* userthis, uint32_t code) {
    // Callback from vcd->open()
    Vsobel* t=(Vsobel*)userthis;
    Vsobel__Syms* __restrict vlSymsp = t->__VlSymsp; // Setup global symbol table
    if (!Verilated::calcUnusedSigs()) vl_fatal(__FILE__,__LINE__,__FILE__,"Turning on wave traces requires Verilated::traceEverOn(true) call before time 0.");
    vcdp->scopeEscape(' ');
    t->traceInitThis (vlSymsp, vcdp, code);
    vcdp->scopeEscape('.');
}
void Vsobel::traceFull(VerilatedVcd* vcdp, void* userthis, uint32_t code) {
    // Callback from vcd->dump()
    Vsobel* t=(Vsobel*)userthis;
    Vsobel__Syms* __restrict vlSymsp = t->__VlSymsp; // Setup global symbol table
    t->traceFullThis (vlSymsp, vcdp, code);
}

//======================


void Vsobel::traceInitThis(Vsobel__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code) {
    Vsobel* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    int c=code;
    if (0 && vcdp && c) {}  // Prevent unused
    vcdp->module(vlSymsp->name()); // Setup signal names
    // Body
    {
	vlTOPp->traceInitThis__1(vlSymsp, vcdp, code);
    }
}

void Vsobel::traceFullThis(Vsobel__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code) {
    Vsobel* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    int c=code;
    if (0 && vcdp && c) {}  // Prevent unused
    // Body
    {
	vlTOPp->traceFullThis__1(vlSymsp, vcdp, code);
    }
    // Final
    vlTOPp->__Vm_traceActivity = 0;
}

void Vsobel::traceInitThis__1(Vsobel__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code) {
    Vsobel* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    int c=code;
    if (0 && vcdp && c) {}  // Prevent unused
    // Body
    {
	vcdp->declBit  (c+13,"clock",-1);
	vcdp->declBit  (c+14,"reset",-1);
	vcdp->declBus  (c+15,"io_m0",-1,9,0);
	vcdp->declBus  (c+16,"io_m1",-1,9,0);
	vcdp->declBus  (c+17,"io_m2",-1,9,0);
	vcdp->declBus  (c+18,"io_m3",-1,9,0);
	vcdp->declBus  (c+19,"io_m5",-1,9,0);
	vcdp->declBus  (c+20,"io_m6",-1,9,0);
	vcdp->declBus  (c+21,"io_m7",-1,9,0);
	vcdp->declBus  (c+22,"io_m8",-1,9,0);
	vcdp->declBus  (c+23,"io_out_X",-1,9,0);
	vcdp->declBus  (c+24,"io_out_Y",-1,9,0);
	vcdp->declBit  (c+13,"v clock",-1);
	vcdp->declBit  (c+14,"v reset",-1);
	vcdp->declBus  (c+15,"v io_m0",-1,9,0);
	vcdp->declBus  (c+16,"v io_m1",-1,9,0);
	vcdp->declBus  (c+17,"v io_m2",-1,9,0);
	vcdp->declBus  (c+18,"v io_m3",-1,9,0);
	vcdp->declBus  (c+19,"v io_m5",-1,9,0);
	vcdp->declBus  (c+20,"v io_m6",-1,9,0);
	vcdp->declBus  (c+21,"v io_m7",-1,9,0);
	vcdp->declBus  (c+22,"v io_m8",-1,9,0);
	vcdp->declBus  (c+23,"v io_out_X",-1,9,0);
	vcdp->declBus  (c+24,"v io_out_Y",-1,9,0);
	vcdp->declBit  (c+1,"v X_dir_io_sel",-1);
	vcdp->declBus  (c+2,"v X_dir_io_in0",-1,9,0);
	vcdp->declBus  (c+3,"v X_dir_io_in1",-1,9,0);
	vcdp->declBus  (c+4,"v X_dir_io_out",-1,9,0);
	// Tracing: v _T_12 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:42
	// Tracing: v _T_13 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:43
	// Tracing: v _T_14 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:44
	// Tracing: v _T_15 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:45
	// Tracing: v _T_16 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:46
	vcdp->declBus  (c+5,"v row_0",-1,9,0);
	// Tracing: v _T_17 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:48
	// Tracing: v _T_18 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:49
	// Tracing: v _T_19 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:50
	// Tracing: v _T_20 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:51
	// Tracing: v _T_21 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:52
	vcdp->declBus  (c+6,"v row_2",-1,9,0);
	// Tracing: v _T_22 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:54
	// Tracing: v _T_26 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:55
	// Tracing: v _T_27 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:56
	// Tracing: v _T_28 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:57
	// Tracing: v _T_29 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:58
	// Tracing: v _T_30 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:59
	// Tracing: v _T_31 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:60
	vcdp->declBit  (c+7,"v Y_dir_io_sel",-1);
	vcdp->declBus  (c+8,"v Y_dir_io_in0",-1,9,0);
	vcdp->declBus  (c+9,"v Y_dir_io_in1",-1,9,0);
	vcdp->declBus  (c+10,"v Y_dir_io_out",-1,9,0);
	// Tracing: v _T_32 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:65
	// Tracing: v _T_33 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:66
	// Tracing: v _T_34 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:67
	// Tracing: v _T_35 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:68
	// Tracing: v _T_36 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:69
	vcdp->declBus  (c+11,"v col_0",-1,9,0);
	// Tracing: v _T_37 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:71
	// Tracing: v _T_38 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:72
	// Tracing: v _T_39 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:73
	// Tracing: v _T_40 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:74
	// Tracing: v _T_41 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:75
	vcdp->declBus  (c+12,"v col_2",-1,9,0);
	// Tracing: v _T_42 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:77
	// Tracing: v _T_46 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:78
	// Tracing: v _T_47 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:79
	// Tracing: v _T_48 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:80
	// Tracing: v _T_49 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:81
	// Tracing: v _T_50 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:82
	// Tracing: v _T_51 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:83
	vcdp->declBit  (c+1,"v X_dir io_sel",-1);
	vcdp->declBus  (c+2,"v X_dir io_in0",-1,9,0);
	vcdp->declBus  (c+3,"v X_dir io_in1",-1,9,0);
	vcdp->declBus  (c+4,"v X_dir io_out",-1,9,0);
	// Tracing: v X_dir _GEN_1 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:20
	vcdp->declBit  (c+7,"v Y_dir io_sel",-1);
	vcdp->declBus  (c+8,"v Y_dir io_in0",-1,9,0);
	vcdp->declBus  (c+9,"v Y_dir io_in1",-1,9,0);
	vcdp->declBus  (c+10,"v Y_dir io_out",-1,9,0);
	// Tracing: v Y_dir _GEN_1 // Ignored: Inlined leading underscore at /users/student/mr106/chhuang/ee6470_106061565/hw5_chisel/sobel_chisel/ChiselProject/test_run_dir/example.test.SobelTester2082036655/sobel.v:20
    }
}

void Vsobel::traceFullThis__1(Vsobel__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code) {
    Vsobel* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    int c=code;
    if (0 && vcdp && c) {}  // Prevent unused
    // Body
    {
	vcdp->fullBit  (c+1,(((0x3ff & (IData)(vlTOPp->v__DOT___T_16)) 
			      > (0x3ff & (IData)(vlTOPp->v__DOT___T_21)))));
	vcdp->fullBus  (c+2,((0x3ff & ((IData)(vlTOPp->v__DOT___T_21) 
				       - (IData)(vlTOPp->v__DOT___T_16)))),10);
	vcdp->fullBus  (c+3,((0x3ff & ((IData)(vlTOPp->v__DOT___T_16) 
				       - (IData)(vlTOPp->v__DOT___T_21)))),10);
	vcdp->fullBus  (c+4,((0x3ff & (((0x3ff & (IData)(vlTOPp->v__DOT___T_16)) 
					> (0x3ff & (IData)(vlTOPp->v__DOT___T_21)))
				        ? ((IData)(vlTOPp->v__DOT___T_16) 
					   - (IData)(vlTOPp->v__DOT___T_21))
				        : ((IData)(vlTOPp->v__DOT___T_21) 
					   - (IData)(vlTOPp->v__DOT___T_16))))),10);
	vcdp->fullBus  (c+5,((0x3ff & (IData)(vlTOPp->v__DOT___T_16))),10);
	vcdp->fullBus  (c+6,((0x3ff & (IData)(vlTOPp->v__DOT___T_21))),10);
	vcdp->fullBit  (c+7,(((0x3ff & (IData)(vlTOPp->v__DOT___T_36)) 
			      > (0x3ff & (IData)(vlTOPp->v__DOT___T_41)))));
	vcdp->fullBus  (c+8,((0x3ff & ((IData)(vlTOPp->v__DOT___T_41) 
				       - (IData)(vlTOPp->v__DOT___T_36)))),10);
	vcdp->fullBus  (c+9,((0x3ff & ((IData)(vlTOPp->v__DOT___T_36) 
				       - (IData)(vlTOPp->v__DOT___T_41)))),10);
	vcdp->fullBus  (c+10,((0x3ff & (((0x3ff & (IData)(vlTOPp->v__DOT___T_36)) 
					 > (0x3ff & (IData)(vlTOPp->v__DOT___T_41)))
					 ? ((IData)(vlTOPp->v__DOT___T_36) 
					    - (IData)(vlTOPp->v__DOT___T_41))
					 : ((IData)(vlTOPp->v__DOT___T_41) 
					    - (IData)(vlTOPp->v__DOT___T_36))))),10);
	vcdp->fullBus  (c+11,((0x3ff & (IData)(vlTOPp->v__DOT___T_36))),10);
	vcdp->fullBus  (c+12,((0x3ff & (IData)(vlTOPp->v__DOT___T_41))),10);
	vcdp->fullBit  (c+13,(vlTOPp->clock));
	vcdp->fullBit  (c+14,(vlTOPp->reset));
	vcdp->fullBus  (c+15,(vlTOPp->io_m0),10);
	vcdp->fullBus  (c+16,(vlTOPp->io_m1),10);
	vcdp->fullBus  (c+17,(vlTOPp->io_m2),10);
	vcdp->fullBus  (c+18,(vlTOPp->io_m3),10);
	vcdp->fullBus  (c+19,(vlTOPp->io_m5),10);
	vcdp->fullBus  (c+20,(vlTOPp->io_m6),10);
	vcdp->fullBus  (c+21,(vlTOPp->io_m7),10);
	vcdp->fullBus  (c+22,(vlTOPp->io_m8),10);
	vcdp->fullBus  (c+23,(vlTOPp->io_out_X),10);
	vcdp->fullBus  (c+24,(vlTOPp->io_out_Y),10);
    }
}
