#ifndef COMPRESS_H_
#define COMPRESS_H_

/* from "jcdctmgr.c" */
#define DIVIDE_BY(a,b)	if (a >= b) a /= b; else a = 0

/* from "jchuff.h" */
#define MAX_COEF_BITS 10

/* from "jpeglib.h" */
typedef struct {
  INT32 put_buffer;		/* current bit-accumulation buffer */
  int put_bits;			/* # of bits now in it */
} savable_state;

/* from "jchuff.h" */
typedef struct {                
  unsigned int ehufco[256];	/* code for each symbol */
  char ehufsi[256];     	/* length of code for each symbol */
  /* If no code has been allocated for a symbol S, ehufsi[S] contains 0 */
} c_derived_tbl;

#endif
