package sobel

import chisel3._
import example._
import config.Parameters

class ExampleTopWithSobel(implicit p: Parameters) extends ExampleTop()(p)
    with PeripherySobel {
  override lazy val module = new ExampleTopWithSobelModule(this, () => new ExampleTopWithSobelBundle(this))
}

class ExampleTopWithSobelBundle[+L <: ExampleTopWithSobel](l: L)
  extends ExampleTopBundle(l)
  with PeripherySobelBundle

class ExampleTopWithSobelModule[+L <: ExampleTopWithSobel, +B <: ExampleTopWithSobelBundle[L]](l: L, b: () => B)
    extends ExampleTopModule(l, b) with PeripherySobelModule
