#!/bin/tcsh

# Imperas environment variables
setenv IMPERAS_HOME "/users/others/jjlab/tools/Imperas"
setenv IMPERAS_UNAME "Linux"
setenv IMPERAS_ARCH "Linux64"
setenv IMPERAS_SHRSUF "so"
setenv IMPERAS_VLNV "$IMPERAS_HOME/lib/$IMPERAS_ARCH/ImperasLib"
setenv IMPERAS_PERSONALITY "CPUMAN_STANDARD"
setenv IMPERAS_RUNTIME "CpuManager"
setenv PATH "${PATH}:${IMPERAS_HOME}/bin/${IMPERAS_ARCH}"
# Imperas License Server
setenv IMPERASD_LICENSE_FILE "27001@ws39.ee.nthu.edu.tw"

# Library 
if ( ! $?LD_LIBRARY_PATH ) then
	setenv LD_LIBRARY_PATH "${IMPERAS_HOME}/bin/${IMPERAS_ARCH}"
else
	setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${IMPERAS_HOME}/bin/${IMPERAS_ARCH}"
endif

setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${IMPERAS_HOME}/lib/${IMPERAS_ARCH}/External/lib"

# add this due to the or32-gcc official build does not able to
# find libmpc.so.2 on ic2X or wsXX correctly.
setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:/home/m101/m101061539/or1k-gcc/lib64:/users/student/mr101/cwchang/lib/or32-elf-1.0rc1/i686-pc-linux-gnu/or1k-elf/lib:/tools/linux/gnu/mpc-0.9.0/lib"
