// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Design implementation internals
// See Vhybrid.h for the primary calling header

#include "Vhybrid.h"           // For This
#include "Vhybrid__Syms.h"

//--------------------
// STATIC VARIABLES


//--------------------

VL_CTOR_IMP(Vhybrid) {
    Vhybrid__Syms* __restrict vlSymsp = __VlSymsp = new Vhybrid__Syms(this, name());
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    VL_CELL (__PVT__hybrid__DOT__R_0, Vhybrid_median5);
    VL_CELL (__PVT__hybrid__DOT__R_1, Vhybrid_median5);
    VL_CELL (__PVT__hybrid__DOT__G_0, Vhybrid_median5);
    VL_CELL (__PVT__hybrid__DOT__G_1, Vhybrid_median5);
    VL_CELL (__PVT__hybrid__DOT__B_0, Vhybrid_median5);
    VL_CELL (__PVT__hybrid__DOT__B_1, Vhybrid_median5);
    // Reset internal values
    
    // Reset structure values
    _ctor_var_reset();
}

void Vhybrid::__Vconfigure(Vhybrid__Syms* vlSymsp, bool first) {
    if (0 && first) {}  // Prevent unused
    this->__VlSymsp = vlSymsp;
}

Vhybrid::~Vhybrid() {
    delete __VlSymsp; __VlSymsp=NULL;
}

//--------------------


void Vhybrid::eval() {
    Vhybrid__Syms* __restrict vlSymsp = this->__VlSymsp; // Setup global symbol table
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Initialize
    if (VL_UNLIKELY(!vlSymsp->__Vm_didInit)) _eval_initial_loop(vlSymsp);
    // Evaluate till stable
    VL_DEBUG_IF(VL_PRINTF("\n----TOP Evaluate Vhybrid::eval\n"); );
    int __VclockLoop = 0;
    QData __Vchange=1;
    while (VL_LIKELY(__Vchange)) {
	VL_DEBUG_IF(VL_PRINTF(" Clock loop\n"););
	vlSymsp->__Vm_activity = true;
	_eval(vlSymsp);
	__Vchange = _change_request(vlSymsp);
	if (++__VclockLoop > 100) vl_fatal(__FILE__,__LINE__,__FILE__,"Verilated model didn't converge");
    }
}

void Vhybrid::_eval_initial_loop(Vhybrid__Syms* __restrict vlSymsp) {
    vlSymsp->__Vm_didInit = true;
    _eval_initial(vlSymsp);
    vlSymsp->__Vm_activity = true;
    int __VclockLoop = 0;
    QData __Vchange=1;
    while (VL_LIKELY(__Vchange)) {
	_eval_settle(vlSymsp);
	_eval(vlSymsp);
	__Vchange = _change_request(vlSymsp);
	if (++__VclockLoop > 100) vl_fatal(__FILE__,__LINE__,__FILE__,"Verilated model didn't DC converge");
    }
}

//--------------------
// Internal Methods

VL_INLINE_OPT void Vhybrid::_sequent__TOP__1(Vhybrid__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vhybrid::_sequent__TOP__1\n"); );
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Variables
    VL_SIG8(__Vdly__hybrid__DOT__R_2__DOT__tbl_0,7,0);
    VL_SIG8(__Vdly__hybrid__DOT__R_2__DOT__tbl_2,7,0);
    VL_SIG8(__Vdly__hybrid__DOT__G_2__DOT__tbl_0,7,0);
    VL_SIG8(__Vdly__hybrid__DOT__G_2__DOT__tbl_2,7,0);
    VL_SIG8(__Vdly__hybrid__DOT__B_2__DOT__tbl_0,7,0);
    VL_SIG8(__Vdly__hybrid__DOT__B_2__DOT__tbl_2,7,0);
    //char	__VpadToAlign10[2];
    // Body
    __Vdly__hybrid__DOT__R_2__DOT__tbl_2 = vlTOPp->hybrid__DOT__R_2__DOT__tbl_2;
    __Vdly__hybrid__DOT__G_2__DOT__tbl_2 = vlTOPp->hybrid__DOT__G_2__DOT__tbl_2;
    __Vdly__hybrid__DOT__B_2__DOT__tbl_2 = vlTOPp->hybrid__DOT__B_2__DOT__tbl_2;
    __Vdly__hybrid__DOT__R_2__DOT__tbl_0 = vlTOPp->hybrid__DOT__R_2__DOT__tbl_0;
    __Vdly__hybrid__DOT__G_2__DOT__tbl_0 = vlTOPp->hybrid__DOT__G_2__DOT__tbl_0;
    __Vdly__hybrid__DOT__B_2__DOT__tbl_0 = vlTOPp->hybrid__DOT__B_2__DOT__tbl_0;
    // ALWAYS at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1745
    if ((6U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
	if (vlTOPp->hybrid__DOT__R_2__DOT___T_23) {
	    __Vdly__hybrid__DOT__R_2__DOT__tbl_2 = vlTOPp->hybrid__DOT__R_2__DOT__tbl_1;
	} else {
	    if ((4U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		if (vlTOPp->hybrid__DOT__R_2__DOT___T_23) {
		    __Vdly__hybrid__DOT__R_2__DOT__tbl_2 
			= vlTOPp->hybrid__DOT__R_2__DOT__tbl_1;
		} else {
		    if ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
			if (vlTOPp->hybrid__DOT__R_2__DOT___T_23) {
			    __Vdly__hybrid__DOT__R_2__DOT__tbl_2 
				= vlTOPp->hybrid__DOT__R_2__DOT__tbl_1;
			} else {
			    if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
				__Vdly__hybrid__DOT__R_2__DOT__tbl_2 
				    = vlTOPp->io_R4;
			    }
			}
		    } else {
			if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			    __Vdly__hybrid__DOT__R_2__DOT__tbl_2 
				= vlTOPp->io_R4;
			}
		    }
		}
	    } else {
		if ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		    if (vlTOPp->hybrid__DOT__R_2__DOT___T_23) {
			__Vdly__hybrid__DOT__R_2__DOT__tbl_2 
			    = vlTOPp->hybrid__DOT__R_2__DOT__tbl_1;
		    } else {
			if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			    __Vdly__hybrid__DOT__R_2__DOT__tbl_2 
				= vlTOPp->io_R4;
			}
		    }
		} else {
		    if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			__Vdly__hybrid__DOT__R_2__DOT__tbl_2 
			    = vlTOPp->io_R4;
		    }
		}
	    }
	}
    } else {
	__Vdly__hybrid__DOT__R_2__DOT__tbl_2 = ((4U 
						 == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						 ? 
						((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_23)
						  ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_1)
						  : 
						 ((2U 
						   == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						   ? 
						  ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_23)
						    ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_1)
						    : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_2))
						   : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_2)))
						 : 
						((2U 
						  == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						  ? 
						 ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_23)
						   ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_1)
						   : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_2))
						  : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_2)));
    }
    // ALWAYS at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1745
    if ((6U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
	if (vlTOPp->hybrid__DOT__G_2__DOT___T_23) {
	    __Vdly__hybrid__DOT__G_2__DOT__tbl_2 = vlTOPp->hybrid__DOT__G_2__DOT__tbl_1;
	} else {
	    if ((4U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		if (vlTOPp->hybrid__DOT__G_2__DOT___T_23) {
		    __Vdly__hybrid__DOT__G_2__DOT__tbl_2 
			= vlTOPp->hybrid__DOT__G_2__DOT__tbl_1;
		} else {
		    if ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
			if (vlTOPp->hybrid__DOT__G_2__DOT___T_23) {
			    __Vdly__hybrid__DOT__G_2__DOT__tbl_2 
				= vlTOPp->hybrid__DOT__G_2__DOT__tbl_1;
			} else {
			    if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
				__Vdly__hybrid__DOT__G_2__DOT__tbl_2 
				    = vlTOPp->io_G4;
			    }
			}
		    } else {
			if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			    __Vdly__hybrid__DOT__G_2__DOT__tbl_2 
				= vlTOPp->io_G4;
			}
		    }
		}
	    } else {
		if ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		    if (vlTOPp->hybrid__DOT__G_2__DOT___T_23) {
			__Vdly__hybrid__DOT__G_2__DOT__tbl_2 
			    = vlTOPp->hybrid__DOT__G_2__DOT__tbl_1;
		    } else {
			if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			    __Vdly__hybrid__DOT__G_2__DOT__tbl_2 
				= vlTOPp->io_G4;
			}
		    }
		} else {
		    if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			__Vdly__hybrid__DOT__G_2__DOT__tbl_2 
			    = vlTOPp->io_G4;
		    }
		}
	    }
	}
    } else {
	__Vdly__hybrid__DOT__G_2__DOT__tbl_2 = ((4U 
						 == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						 ? 
						((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_23)
						  ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_1)
						  : 
						 ((2U 
						   == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						   ? 
						  ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_23)
						    ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_1)
						    : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_2))
						   : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_2)))
						 : 
						((2U 
						  == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						  ? 
						 ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_23)
						   ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_1)
						   : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_2))
						  : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_2)));
    }
    // ALWAYS at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1745
    if ((6U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
	if (vlTOPp->hybrid__DOT__B_2__DOT___T_23) {
	    __Vdly__hybrid__DOT__B_2__DOT__tbl_2 = vlTOPp->hybrid__DOT__B_2__DOT__tbl_1;
	} else {
	    if ((4U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		if (vlTOPp->hybrid__DOT__B_2__DOT___T_23) {
		    __Vdly__hybrid__DOT__B_2__DOT__tbl_2 
			= vlTOPp->hybrid__DOT__B_2__DOT__tbl_1;
		} else {
		    if ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
			if (vlTOPp->hybrid__DOT__B_2__DOT___T_23) {
			    __Vdly__hybrid__DOT__B_2__DOT__tbl_2 
				= vlTOPp->hybrid__DOT__B_2__DOT__tbl_1;
			} else {
			    if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
				__Vdly__hybrid__DOT__B_2__DOT__tbl_2 
				    = vlTOPp->io_B4;
			    }
			}
		    } else {
			if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			    __Vdly__hybrid__DOT__B_2__DOT__tbl_2 
				= vlTOPp->io_B4;
			}
		    }
		}
	    } else {
		if ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		    if (vlTOPp->hybrid__DOT__B_2__DOT___T_23) {
			__Vdly__hybrid__DOT__B_2__DOT__tbl_2 
			    = vlTOPp->hybrid__DOT__B_2__DOT__tbl_1;
		    } else {
			if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			    __Vdly__hybrid__DOT__B_2__DOT__tbl_2 
				= vlTOPp->io_B4;
			}
		    }
		} else {
		    if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			__Vdly__hybrid__DOT__B_2__DOT__tbl_2 
			    = vlTOPp->io_B4;
		    }
		}
	    }
	}
    } else {
	__Vdly__hybrid__DOT__B_2__DOT__tbl_2 = ((4U 
						 == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						 ? 
						((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_23)
						  ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_1)
						  : 
						 ((2U 
						   == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						   ? 
						  ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_23)
						    ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_1)
						    : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_2))
						   : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_2)))
						 : 
						((2U 
						  == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						  ? 
						 ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_23)
						   ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_1)
						   : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_2))
						  : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_2)));
    }
    // ALWAYS at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1519
    if ((5U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
	if (vlTOPp->hybrid__DOT__R_2__DOT___T_20) {
	    __Vdly__hybrid__DOT__R_2__DOT__tbl_0 = vlTOPp->hybrid__DOT__R_2__DOT__tbl_1;
	} else {
	    if ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		if (vlTOPp->hybrid__DOT__R_2__DOT___T_20) {
		    __Vdly__hybrid__DOT__R_2__DOT__tbl_0 
			= vlTOPp->hybrid__DOT__R_2__DOT__tbl_1;
		} else {
		    if ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
			if (vlTOPp->hybrid__DOT__R_2__DOT___T_20) {
			    __Vdly__hybrid__DOT__R_2__DOT__tbl_0 
				= vlTOPp->hybrid__DOT__R_2__DOT__tbl_1;
			} else {
			    if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
				__Vdly__hybrid__DOT__R_2__DOT__tbl_0 
				    = vlSymsp->TOP__hybrid__DOT__R_0.__PVT__tbl_2;
			    }
			}
		    } else {
			if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			    __Vdly__hybrid__DOT__R_2__DOT__tbl_0 
				= vlSymsp->TOP__hybrid__DOT__R_0.__PVT__tbl_2;
			}
		    }
		}
	    } else {
		if ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		    if (vlTOPp->hybrid__DOT__R_2__DOT___T_20) {
			__Vdly__hybrid__DOT__R_2__DOT__tbl_0 
			    = vlTOPp->hybrid__DOT__R_2__DOT__tbl_1;
		    } else {
			if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			    __Vdly__hybrid__DOT__R_2__DOT__tbl_0 
				= vlSymsp->TOP__hybrid__DOT__R_0.__PVT__tbl_2;
			}
		    }
		} else {
		    if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			__Vdly__hybrid__DOT__R_2__DOT__tbl_0 
			    = vlSymsp->TOP__hybrid__DOT__R_0.__PVT__tbl_2;
		    }
		}
	    }
	}
    } else {
	__Vdly__hybrid__DOT__R_2__DOT__tbl_0 = ((3U 
						 == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						 ? 
						((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_20)
						  ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_1)
						  : 
						 ((1U 
						   == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						   ? 
						  ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_20)
						    ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_1)
						    : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_0))
						   : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_0)))
						 : 
						((1U 
						  == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						  ? 
						 ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_20)
						   ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_1)
						   : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_0))
						  : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_0)));
    }
    // ALWAYS at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1519
    if ((5U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
	if (vlTOPp->hybrid__DOT__G_2__DOT___T_20) {
	    __Vdly__hybrid__DOT__G_2__DOT__tbl_0 = vlTOPp->hybrid__DOT__G_2__DOT__tbl_1;
	} else {
	    if ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		if (vlTOPp->hybrid__DOT__G_2__DOT___T_20) {
		    __Vdly__hybrid__DOT__G_2__DOT__tbl_0 
			= vlTOPp->hybrid__DOT__G_2__DOT__tbl_1;
		} else {
		    if ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
			if (vlTOPp->hybrid__DOT__G_2__DOT___T_20) {
			    __Vdly__hybrid__DOT__G_2__DOT__tbl_0 
				= vlTOPp->hybrid__DOT__G_2__DOT__tbl_1;
			} else {
			    if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
				__Vdly__hybrid__DOT__G_2__DOT__tbl_0 
				    = vlSymsp->TOP__hybrid__DOT__G_0.__PVT__tbl_2;
			    }
			}
		    } else {
			if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			    __Vdly__hybrid__DOT__G_2__DOT__tbl_0 
				= vlSymsp->TOP__hybrid__DOT__G_0.__PVT__tbl_2;
			}
		    }
		}
	    } else {
		if ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		    if (vlTOPp->hybrid__DOT__G_2__DOT___T_20) {
			__Vdly__hybrid__DOT__G_2__DOT__tbl_0 
			    = vlTOPp->hybrid__DOT__G_2__DOT__tbl_1;
		    } else {
			if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			    __Vdly__hybrid__DOT__G_2__DOT__tbl_0 
				= vlSymsp->TOP__hybrid__DOT__G_0.__PVT__tbl_2;
			}
		    }
		} else {
		    if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			__Vdly__hybrid__DOT__G_2__DOT__tbl_0 
			    = vlSymsp->TOP__hybrid__DOT__G_0.__PVT__tbl_2;
		    }
		}
	    }
	}
    } else {
	__Vdly__hybrid__DOT__G_2__DOT__tbl_0 = ((3U 
						 == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						 ? 
						((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_20)
						  ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_1)
						  : 
						 ((1U 
						   == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						   ? 
						  ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_20)
						    ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_1)
						    : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_0))
						   : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_0)))
						 : 
						((1U 
						  == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						  ? 
						 ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_20)
						   ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_1)
						   : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_0))
						  : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_0)));
    }
    // ALWAYS at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1519
    if ((5U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
	if (vlTOPp->hybrid__DOT__B_2__DOT___T_20) {
	    __Vdly__hybrid__DOT__B_2__DOT__tbl_0 = vlTOPp->hybrid__DOT__B_2__DOT__tbl_1;
	} else {
	    if ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		if (vlTOPp->hybrid__DOT__B_2__DOT___T_20) {
		    __Vdly__hybrid__DOT__B_2__DOT__tbl_0 
			= vlTOPp->hybrid__DOT__B_2__DOT__tbl_1;
		} else {
		    if ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
			if (vlTOPp->hybrid__DOT__B_2__DOT___T_20) {
			    __Vdly__hybrid__DOT__B_2__DOT__tbl_0 
				= vlTOPp->hybrid__DOT__B_2__DOT__tbl_1;
			} else {
			    if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
				__Vdly__hybrid__DOT__B_2__DOT__tbl_0 
				    = vlSymsp->TOP__hybrid__DOT__B_0.__PVT__tbl_2;
			    }
			}
		    } else {
			if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			    __Vdly__hybrid__DOT__B_2__DOT__tbl_0 
				= vlSymsp->TOP__hybrid__DOT__B_0.__PVT__tbl_2;
			}
		    }
		}
	    } else {
		if ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		    if (vlTOPp->hybrid__DOT__B_2__DOT___T_20) {
			__Vdly__hybrid__DOT__B_2__DOT__tbl_0 
			    = vlTOPp->hybrid__DOT__B_2__DOT__tbl_1;
		    } else {
			if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			    __Vdly__hybrid__DOT__B_2__DOT__tbl_0 
				= vlSymsp->TOP__hybrid__DOT__B_0.__PVT__tbl_2;
			}
		    }
		} else {
		    if ((0xfU == (IData)(vlTOPp->hybrid__DOT__cnt))) {
			__Vdly__hybrid__DOT__B_2__DOT__tbl_0 
			    = vlSymsp->TOP__hybrid__DOT__B_0.__PVT__tbl_2;
		    }
		}
	    }
	}
    } else {
	__Vdly__hybrid__DOT__B_2__DOT__tbl_0 = ((3U 
						 == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						 ? 
						((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_20)
						  ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_1)
						  : 
						 ((1U 
						   == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						   ? 
						  ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_20)
						    ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_1)
						    : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_0))
						   : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_0)))
						 : 
						((1U 
						  == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						  ? 
						 ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_20)
						   ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_1)
						   : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_0))
						  : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_0)));
    }
    // ALWAYS at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1584
    if ((6U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
	if (vlTOPp->hybrid__DOT__R_2__DOT___T_23) {
	    vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 = vlTOPp->hybrid__DOT__R_2__DOT__tbl_2;
	} else {
	    if ((5U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		if (vlTOPp->hybrid__DOT__R_2__DOT___T_20) {
		    vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 
			= vlTOPp->hybrid__DOT__R_2__DOT__tbl_0;
		} else {
		    if ((4U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
			if (vlTOPp->hybrid__DOT__R_2__DOT___T_23) {
			    vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 
				= vlTOPp->hybrid__DOT__R_2__DOT__tbl_2;
			} else {
			    if ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
				if (vlTOPp->hybrid__DOT__R_2__DOT___T_20) {
				    vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 
					= vlTOPp->hybrid__DOT__R_2__DOT__tbl_0;
				} else {
				    if ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
					if (vlTOPp->hybrid__DOT__R_2__DOT___T_23) {
					    vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 
						= vlTOPp->hybrid__DOT__R_2__DOT__tbl_2;
					} else {
					    if ((1U 
						 == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
						if (vlTOPp->hybrid__DOT__R_2__DOT___T_20) {
						    vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 
							= vlTOPp->hybrid__DOT__R_2__DOT__tbl_0;
						} else {
						    if (
							(0xfU 
							 == (IData)(vlTOPp->hybrid__DOT__cnt))) {
							vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 
							    = vlSymsp->TOP__hybrid__DOT__R_1.__PVT__tbl_2;
						    }
						}
					    } else {
						if (
						    (0xfU 
						     == (IData)(vlTOPp->hybrid__DOT__cnt))) {
						    vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 
							= vlSymsp->TOP__hybrid__DOT__R_1.__PVT__tbl_2;
						}
					    }
					}
				    } else {
					if ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
					    if (vlTOPp->hybrid__DOT__R_2__DOT___T_20) {
						vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 
						    = vlTOPp->hybrid__DOT__R_2__DOT__tbl_0;
					    } else {
						if (
						    (0xfU 
						     == (IData)(vlTOPp->hybrid__DOT__cnt))) {
						    vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 
							= vlSymsp->TOP__hybrid__DOT__R_1.__PVT__tbl_2;
						}
					    }
					} else {
					    if ((0xfU 
						 == (IData)(vlTOPp->hybrid__DOT__cnt))) {
						vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 
						    = vlSymsp->TOP__hybrid__DOT__R_1.__PVT__tbl_2;
					    }
					}
				    }
				}
			    } else {
				vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 
				    = ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
				        ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_23)
					    ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_2)
					    : ((1U 
						== (IData)(vlTOPp->hybrid__DOT__cnt_1))
					        ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_20)
						    ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0)
						    : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_1))
					        : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_1)))
				        : ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					    ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_20)
					        ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0)
					        : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_1))
					    : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_1)));
			    }
			}
		    } else {
			vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 
			    = ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
			        ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_20)
				    ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0)
				    : ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
				        ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_23)
					    ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_2)
					    : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_5))
				        : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_5)))
			        : ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
				    ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_23)
				        ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_2)
				        : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_5))
				    : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_5)));
		    }
		}
	    } else {
		vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 
		    = ((4U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
		        ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_23)
			    ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_2)
			    : ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
			        ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_20)
				    ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0)
				    : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_10))
			        : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_10)))
		        : ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
			    ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_20)
			        ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0)
			        : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_10))
			    : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_10)));
	    }
	}
    } else {
	vlTOPp->hybrid__DOT__R_2__DOT__tbl_1 = ((5U 
						 == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						 ? 
						((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_20)
						  ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0)
						  : 
						 ((4U 
						   == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						   ? 
						  ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_23)
						    ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_2)
						    : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_13))
						   : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_13)))
						 : 
						((4U 
						  == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						  ? 
						 ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_23)
						   ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_2)
						   : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_13))
						  : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_13)));
    }
    // ALWAYS at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1584
    if ((6U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
	if (vlTOPp->hybrid__DOT__G_2__DOT___T_23) {
	    vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 = vlTOPp->hybrid__DOT__G_2__DOT__tbl_2;
	} else {
	    if ((5U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		if (vlTOPp->hybrid__DOT__G_2__DOT___T_20) {
		    vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 
			= vlTOPp->hybrid__DOT__G_2__DOT__tbl_0;
		} else {
		    if ((4U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
			if (vlTOPp->hybrid__DOT__G_2__DOT___T_23) {
			    vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 
				= vlTOPp->hybrid__DOT__G_2__DOT__tbl_2;
			} else {
			    if ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
				if (vlTOPp->hybrid__DOT__G_2__DOT___T_20) {
				    vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 
					= vlTOPp->hybrid__DOT__G_2__DOT__tbl_0;
				} else {
				    if ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
					if (vlTOPp->hybrid__DOT__G_2__DOT___T_23) {
					    vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 
						= vlTOPp->hybrid__DOT__G_2__DOT__tbl_2;
					} else {
					    if ((1U 
						 == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
						if (vlTOPp->hybrid__DOT__G_2__DOT___T_20) {
						    vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 
							= vlTOPp->hybrid__DOT__G_2__DOT__tbl_0;
						} else {
						    if (
							(0xfU 
							 == (IData)(vlTOPp->hybrid__DOT__cnt))) {
							vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 
							    = vlSymsp->TOP__hybrid__DOT__G_1.__PVT__tbl_2;
						    }
						}
					    } else {
						if (
						    (0xfU 
						     == (IData)(vlTOPp->hybrid__DOT__cnt))) {
						    vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 
							= vlSymsp->TOP__hybrid__DOT__G_1.__PVT__tbl_2;
						}
					    }
					}
				    } else {
					if ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
					    if (vlTOPp->hybrid__DOT__G_2__DOT___T_20) {
						vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 
						    = vlTOPp->hybrid__DOT__G_2__DOT__tbl_0;
					    } else {
						if (
						    (0xfU 
						     == (IData)(vlTOPp->hybrid__DOT__cnt))) {
						    vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 
							= vlSymsp->TOP__hybrid__DOT__G_1.__PVT__tbl_2;
						}
					    }
					} else {
					    if ((0xfU 
						 == (IData)(vlTOPp->hybrid__DOT__cnt))) {
						vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 
						    = vlSymsp->TOP__hybrid__DOT__G_1.__PVT__tbl_2;
					    }
					}
				    }
				}
			    } else {
				vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 
				    = ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
				        ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_23)
					    ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_2)
					    : ((1U 
						== (IData)(vlTOPp->hybrid__DOT__cnt_1))
					        ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_20)
						    ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0)
						    : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_1))
					        : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_1)))
				        : ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					    ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_20)
					        ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0)
					        : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_1))
					    : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_1)));
			    }
			}
		    } else {
			vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 
			    = ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
			        ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_20)
				    ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0)
				    : ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
				        ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_23)
					    ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_2)
					    : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_5))
				        : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_5)))
			        : ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
				    ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_23)
				        ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_2)
				        : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_5))
				    : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_5)));
		    }
		}
	    } else {
		vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 
		    = ((4U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
		        ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_23)
			    ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_2)
			    : ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
			        ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_20)
				    ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0)
				    : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_10))
			        : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_10)))
		        : ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
			    ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_20)
			        ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0)
			        : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_10))
			    : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_10)));
	    }
	}
    } else {
	vlTOPp->hybrid__DOT__G_2__DOT__tbl_1 = ((5U 
						 == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						 ? 
						((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_20)
						  ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0)
						  : 
						 ((4U 
						   == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						   ? 
						  ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_23)
						    ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_2)
						    : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_13))
						   : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_13)))
						 : 
						((4U 
						  == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						  ? 
						 ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_23)
						   ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_2)
						   : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_13))
						  : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_13)));
    }
    // ALWAYS at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:1584
    if ((6U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
	if (vlTOPp->hybrid__DOT__B_2__DOT___T_23) {
	    vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 = vlTOPp->hybrid__DOT__B_2__DOT__tbl_2;
	} else {
	    if ((5U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
		if (vlTOPp->hybrid__DOT__B_2__DOT___T_20) {
		    vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 
			= vlTOPp->hybrid__DOT__B_2__DOT__tbl_0;
		} else {
		    if ((4U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
			if (vlTOPp->hybrid__DOT__B_2__DOT___T_23) {
			    vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 
				= vlTOPp->hybrid__DOT__B_2__DOT__tbl_2;
			} else {
			    if ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
				if (vlTOPp->hybrid__DOT__B_2__DOT___T_20) {
				    vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 
					= vlTOPp->hybrid__DOT__B_2__DOT__tbl_0;
				} else {
				    if ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
					if (vlTOPp->hybrid__DOT__B_2__DOT___T_23) {
					    vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 
						= vlTOPp->hybrid__DOT__B_2__DOT__tbl_2;
					} else {
					    if ((1U 
						 == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
						if (vlTOPp->hybrid__DOT__B_2__DOT___T_20) {
						    vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 
							= vlTOPp->hybrid__DOT__B_2__DOT__tbl_0;
						} else {
						    if (
							(0xfU 
							 == (IData)(vlTOPp->hybrid__DOT__cnt))) {
							vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 
							    = vlSymsp->TOP__hybrid__DOT__B_1.__PVT__tbl_2;
						    }
						}
					    } else {
						if (
						    (0xfU 
						     == (IData)(vlTOPp->hybrid__DOT__cnt))) {
						    vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 
							= vlSymsp->TOP__hybrid__DOT__B_1.__PVT__tbl_2;
						}
					    }
					}
				    } else {
					if ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))) {
					    if (vlTOPp->hybrid__DOT__B_2__DOT___T_20) {
						vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 
						    = vlTOPp->hybrid__DOT__B_2__DOT__tbl_0;
					    } else {
						if (
						    (0xfU 
						     == (IData)(vlTOPp->hybrid__DOT__cnt))) {
						    vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 
							= vlSymsp->TOP__hybrid__DOT__B_1.__PVT__tbl_2;
						}
					    }
					} else {
					    if ((0xfU 
						 == (IData)(vlTOPp->hybrid__DOT__cnt))) {
						vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 
						    = vlSymsp->TOP__hybrid__DOT__B_1.__PVT__tbl_2;
					    }
					}
				    }
				}
			    } else {
				vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 
				    = ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
				        ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_23)
					    ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_2)
					    : ((1U 
						== (IData)(vlTOPp->hybrid__DOT__cnt_1))
					        ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_20)
						    ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0)
						    : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_1))
					        : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_1)))
				        : ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					    ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_20)
					        ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0)
					        : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_1))
					    : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_1)));
			    }
			}
		    } else {
			vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 
			    = ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
			        ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_20)
				    ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0)
				    : ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
				        ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_23)
					    ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_2)
					    : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_5))
				        : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_5)))
			        : ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
				    ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_23)
				        ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_2)
				        : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_5))
				    : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_5)));
		    }
		}
	    } else {
		vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 
		    = ((4U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
		        ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_23)
			    ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_2)
			    : ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
			        ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_20)
				    ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0)
				    : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_10))
			        : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_10)))
		        : ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
			    ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_20)
			        ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0)
			        : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_10))
			    : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_10)));
	    }
	}
    } else {
	vlTOPp->hybrid__DOT__B_2__DOT__tbl_1 = ((5U 
						 == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						 ? 
						((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_20)
						  ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0)
						  : 
						 ((4U 
						   == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						   ? 
						  ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_23)
						    ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_2)
						    : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_13))
						   : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_13)))
						 : 
						((4U 
						  == (IData)(vlTOPp->hybrid__DOT__cnt_1))
						  ? 
						 ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_23)
						   ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_2)
						   : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_13))
						  : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_13)));
    }
    vlTOPp->hybrid__DOT__R_2__DOT__tbl_2 = __Vdly__hybrid__DOT__R_2__DOT__tbl_2;
    vlTOPp->hybrid__DOT__R_2__DOT__tbl_0 = __Vdly__hybrid__DOT__R_2__DOT__tbl_0;
    vlTOPp->hybrid__DOT__G_2__DOT__tbl_2 = __Vdly__hybrid__DOT__G_2__DOT__tbl_2;
    vlTOPp->hybrid__DOT__G_2__DOT__tbl_0 = __Vdly__hybrid__DOT__G_2__DOT__tbl_0;
    vlTOPp->hybrid__DOT__B_2__DOT__tbl_2 = __Vdly__hybrid__DOT__B_2__DOT__tbl_2;
    vlTOPp->hybrid__DOT__B_2__DOT__tbl_0 = __Vdly__hybrid__DOT__B_2__DOT__tbl_0;
    vlTOPp->io_ansR = vlTOPp->hybrid__DOT__R_2__DOT__tbl_1;
    vlTOPp->hybrid__DOT__R_2__DOT___T_23 = ((IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_2) 
					    < (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_1));
    vlTOPp->hybrid__DOT__R_2__DOT___T_20 = ((IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_1) 
					    < (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0));
    vlTOPp->io_ansG = vlTOPp->hybrid__DOT__G_2__DOT__tbl_1;
    vlTOPp->hybrid__DOT__G_2__DOT___T_23 = ((IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_2) 
					    < (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_1));
    vlTOPp->hybrid__DOT__G_2__DOT___T_20 = ((IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_1) 
					    < (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0));
    vlTOPp->io_ansB = vlTOPp->hybrid__DOT__B_2__DOT__tbl_1;
    vlTOPp->hybrid__DOT__B_2__DOT___T_23 = ((IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_2) 
					    < (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_1));
    vlTOPp->hybrid__DOT__B_2__DOT___T_20 = ((IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_1) 
					    < (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0));
}

VL_INLINE_OPT void Vhybrid::_sequent__TOP__2(Vhybrid__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vhybrid::_sequent__TOP__2\n"); );
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    // ALWAYS at /users/student/mr106/chhuang/ee6470_106061565/midterm_project_rgb/platform/ChiselProject/test_run_dir/example.test.GCDTester168775820/hybrid.v:2132
    if (vlTOPp->reset) {
	vlTOPp->hybrid__DOT__cnt = 1U;
    } else {
	if (vlTOPp->hybrid__DOT___T_36) {
	    vlTOPp->hybrid__DOT__cnt = vlTOPp->hybrid__DOT___T_39;
	} else {
	    if (vlTOPp->io_e) {
		vlTOPp->hybrid__DOT__cnt = 1U;
	    }
	}
    }
    if (vlTOPp->reset) {
	vlTOPp->hybrid__DOT__cnt_1 = 1U;
    } else {
	if (vlTOPp->hybrid__DOT___T_44) {
	    vlTOPp->hybrid__DOT__cnt_1 = vlTOPp->hybrid__DOT___T_47;
	} else {
	    if (vlTOPp->hybrid__DOT___T_50) {
		vlTOPp->hybrid__DOT__cnt_1 = 1U;
	    } else {
		if (vlTOPp->hybrid__DOT___T_53) {
		    vlTOPp->hybrid__DOT__cnt_1 = vlTOPp->hybrid__DOT___T_47;
		}
	    }
	}
    }
    vlTOPp->hybrid__DOT___T_47 = (0x1fU & ((IData)(1U) 
					   + (IData)(vlTOPp->hybrid__DOT__cnt_1)));
    vlTOPp->hybrid__DOT___T_53 = (1U < (IData)(vlTOPp->hybrid__DOT__cnt_1));
    vlTOPp->hybrid__DOT___T_36 = (0x10U > (IData)(vlTOPp->hybrid__DOT__cnt));
    vlTOPp->hybrid__DOT___T_39 = (0x1fU & ((IData)(1U) 
					   + (IData)(vlTOPp->hybrid__DOT__cnt)));
    vlTOPp->hybrid__DOT___T_44 = (0xfU == (IData)(vlTOPp->hybrid__DOT__cnt));
    vlTOPp->hybrid__DOT__R_2__DOT___GEN_0 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlSymsp->TOP__hybrid__DOT__R_0.__PVT__tbl_2)
					      : (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0));
    vlTOPp->hybrid__DOT__G_2__DOT___GEN_0 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlSymsp->TOP__hybrid__DOT__G_0.__PVT__tbl_2)
					      : (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0));
    vlTOPp->hybrid__DOT__B_2__DOT___GEN_0 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlSymsp->TOP__hybrid__DOT__B_0.__PVT__tbl_2)
					      : (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0));
    vlTOPp->hybrid__DOT__R_2__DOT___GEN_1 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlSymsp->TOP__hybrid__DOT__R_1.__PVT__tbl_2)
					      : (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_1));
    vlTOPp->hybrid__DOT__G_2__DOT___GEN_1 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlSymsp->TOP__hybrid__DOT__G_1.__PVT__tbl_2)
					      : (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_1));
    vlTOPp->hybrid__DOT__B_2__DOT___GEN_1 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlSymsp->TOP__hybrid__DOT__B_1.__PVT__tbl_2)
					      : (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_1));
}

void Vhybrid::_settle__TOP__3(Vhybrid__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vhybrid::_settle__TOP__3\n"); );
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->io_ansR = vlTOPp->hybrid__DOT__R_2__DOT__tbl_1;
    vlTOPp->hybrid__DOT__R_2__DOT___T_23 = ((IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_2) 
					    < (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_1));
    vlTOPp->hybrid__DOT__R_2__DOT___T_20 = ((IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_1) 
					    < (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0));
    vlTOPp->io_ansG = vlTOPp->hybrid__DOT__G_2__DOT__tbl_1;
    vlTOPp->hybrid__DOT__G_2__DOT___T_23 = ((IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_2) 
					    < (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_1));
    vlTOPp->hybrid__DOT__G_2__DOT___T_20 = ((IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_1) 
					    < (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0));
    vlTOPp->io_ansB = vlTOPp->hybrid__DOT__B_2__DOT__tbl_1;
    vlTOPp->hybrid__DOT__B_2__DOT___T_23 = ((IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_2) 
					    < (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_1));
    vlTOPp->hybrid__DOT__B_2__DOT___T_20 = ((IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_1) 
					    < (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0));
    vlTOPp->hybrid__DOT___T_47 = (0x1fU & ((IData)(1U) 
					   + (IData)(vlTOPp->hybrid__DOT__cnt_1)));
    vlTOPp->hybrid__DOT___T_53 = (1U < (IData)(vlTOPp->hybrid__DOT__cnt_1));
    vlTOPp->hybrid__DOT___T_50 = ((IData)(vlTOPp->io_e) 
				  | (6U == (IData)(vlTOPp->hybrid__DOT__cnt_1)));
    vlTOPp->hybrid__DOT___T_36 = (0x10U > (IData)(vlTOPp->hybrid__DOT__cnt));
    vlTOPp->hybrid__DOT___T_39 = (0x1fU & ((IData)(1U) 
					   + (IData)(vlTOPp->hybrid__DOT__cnt)));
    vlTOPp->hybrid__DOT___T_44 = (0xfU == (IData)(vlTOPp->hybrid__DOT__cnt));
    vlTOPp->hybrid__DOT__R_2__DOT___GEN_0 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlSymsp->TOP__hybrid__DOT__R_0.__PVT__tbl_2)
					      : (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0));
    vlTOPp->hybrid__DOT__R_2__DOT___GEN_2 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlTOPp->io_R4)
					      : (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_2));
    vlTOPp->hybrid__DOT__G_2__DOT___GEN_0 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlSymsp->TOP__hybrid__DOT__G_0.__PVT__tbl_2)
					      : (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0));
    vlTOPp->hybrid__DOT__G_2__DOT___GEN_2 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlTOPp->io_G4)
					      : (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_2));
    vlTOPp->hybrid__DOT__B_2__DOT___GEN_0 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlSymsp->TOP__hybrid__DOT__B_0.__PVT__tbl_2)
					      : (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0));
    vlTOPp->hybrid__DOT__B_2__DOT___GEN_2 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlTOPp->io_B4)
					      : (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_2));
    vlTOPp->hybrid__DOT__R_2__DOT___GEN_1 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlSymsp->TOP__hybrid__DOT__R_1.__PVT__tbl_2)
					      : (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_1));
    vlTOPp->hybrid__DOT__G_2__DOT___GEN_1 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlSymsp->TOP__hybrid__DOT__G_1.__PVT__tbl_2)
					      : (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_1));
    vlTOPp->hybrid__DOT__B_2__DOT___GEN_1 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlSymsp->TOP__hybrid__DOT__B_1.__PVT__tbl_2)
					      : (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_1));
    vlTOPp->hybrid__DOT__R_2__DOT___GEN_5 = ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					      ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_20)
						  ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0)
						  : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_1))
					      : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_1));
    vlTOPp->hybrid__DOT__G_2__DOT___GEN_5 = ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					      ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_20)
						  ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0)
						  : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_1))
					      : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_1));
    vlTOPp->hybrid__DOT__B_2__DOT___GEN_5 = ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					      ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_20)
						  ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0)
						  : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_1))
					      : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_1));
}

VL_INLINE_OPT void Vhybrid::_combo__TOP__4(Vhybrid__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vhybrid::_combo__TOP__4\n"); );
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->hybrid__DOT___T_50 = ((IData)(vlTOPp->io_e) 
				  | (6U == (IData)(vlTOPp->hybrid__DOT__cnt_1)));
    vlTOPp->hybrid__DOT__R_2__DOT___GEN_2 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlTOPp->io_R4)
					      : (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_2));
    vlTOPp->hybrid__DOT__G_2__DOT___GEN_2 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlTOPp->io_G4)
					      : (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_2));
    vlTOPp->hybrid__DOT__B_2__DOT___GEN_2 = ((0xfU 
					      == (IData)(vlTOPp->hybrid__DOT__cnt))
					      ? (IData)(vlTOPp->io_B4)
					      : (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_2));
}

VL_INLINE_OPT void Vhybrid::_sequent__TOP__5(Vhybrid__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vhybrid::_sequent__TOP__5\n"); );
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->hybrid__DOT__R_2__DOT___GEN_5 = ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					      ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_20)
						  ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0)
						  : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_1))
					      : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_1));
    vlTOPp->hybrid__DOT__G_2__DOT___GEN_5 = ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					      ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_20)
						  ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0)
						  : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_1))
					      : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_1));
    vlTOPp->hybrid__DOT__B_2__DOT___GEN_5 = ((1U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					      ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_20)
						  ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0)
						  : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_1))
					      : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_1));
    vlTOPp->hybrid__DOT__R_2__DOT___GEN_10 = ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					       ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_23)
						   ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_2)
						   : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_5))
					       : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_5));
    vlTOPp->hybrid__DOT__G_2__DOT___GEN_10 = ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					       ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_23)
						   ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_2)
						   : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_5))
					       : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_5));
    vlTOPp->hybrid__DOT__B_2__DOT___GEN_10 = ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					       ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_23)
						   ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_2)
						   : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_5))
					       : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_5));
}

void Vhybrid::_settle__TOP__6(Vhybrid__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vhybrid::_settle__TOP__6\n"); );
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->hybrid__DOT__R_2__DOT___GEN_10 = ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					       ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_23)
						   ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_2)
						   : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_5))
					       : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_5));
    vlTOPp->hybrid__DOT__G_2__DOT___GEN_10 = ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					       ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_23)
						   ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_2)
						   : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_5))
					       : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_5));
    vlTOPp->hybrid__DOT__B_2__DOT___GEN_10 = ((2U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					       ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_23)
						   ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_2)
						   : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_5))
					       : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_5));
    vlTOPp->hybrid__DOT__R_2__DOT___GEN_13 = ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					       ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_20)
						   ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0)
						   : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_10))
					       : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_10));
    vlTOPp->hybrid__DOT__G_2__DOT___GEN_13 = ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					       ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_20)
						   ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0)
						   : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_10))
					       : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_10));
    vlTOPp->hybrid__DOT__B_2__DOT___GEN_13 = ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					       ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_20)
						   ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0)
						   : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_10))
					       : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_10));
}

VL_INLINE_OPT void Vhybrid::_sequent__TOP__7(Vhybrid__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vhybrid::_sequent__TOP__7\n"); );
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->hybrid__DOT__R_2__DOT___GEN_13 = ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					       ? ((IData)(vlTOPp->hybrid__DOT__R_2__DOT___T_20)
						   ? (IData)(vlTOPp->hybrid__DOT__R_2__DOT__tbl_0)
						   : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_10))
					       : (IData)(vlTOPp->hybrid__DOT__R_2__DOT___GEN_10));
    vlTOPp->hybrid__DOT__G_2__DOT___GEN_13 = ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					       ? ((IData)(vlTOPp->hybrid__DOT__G_2__DOT___T_20)
						   ? (IData)(vlTOPp->hybrid__DOT__G_2__DOT__tbl_0)
						   : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_10))
					       : (IData)(vlTOPp->hybrid__DOT__G_2__DOT___GEN_10));
    vlTOPp->hybrid__DOT__B_2__DOT___GEN_13 = ((3U == (IData)(vlTOPp->hybrid__DOT__cnt_1))
					       ? ((IData)(vlTOPp->hybrid__DOT__B_2__DOT___T_20)
						   ? (IData)(vlTOPp->hybrid__DOT__B_2__DOT__tbl_0)
						   : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_10))
					       : (IData)(vlTOPp->hybrid__DOT__B_2__DOT___GEN_10));
}

void Vhybrid::_eval(Vhybrid__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vhybrid::_eval\n"); );
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    if (((IData)(vlTOPp->clock) & (~ (IData)(vlTOPp->__Vclklast__TOP__clock)))) {
	vlTOPp->_sequent__TOP__1(vlSymsp);
	vlTOPp->__Vm_traceActivity = (2U | vlTOPp->__Vm_traceActivity);
	vlSymsp->TOP__hybrid__DOT__R_0._sequent__TOP__hybrid__DOT__R_0__1(vlSymsp);
	vlSymsp->TOP__hybrid__DOT__R_1._sequent__TOP__hybrid__DOT__R_1__2(vlSymsp);
	vlSymsp->TOP__hybrid__DOT__G_0._sequent__TOP__hybrid__DOT__G_0__3(vlSymsp);
	vlSymsp->TOP__hybrid__DOT__G_1._sequent__TOP__hybrid__DOT__G_1__4(vlSymsp);
	vlSymsp->TOP__hybrid__DOT__B_0._sequent__TOP__hybrid__DOT__B_0__5(vlSymsp);
	vlSymsp->TOP__hybrid__DOT__B_1._sequent__TOP__hybrid__DOT__B_1__6(vlSymsp);
	vlTOPp->_sequent__TOP__2(vlSymsp);
    }
    vlSymsp->TOP__hybrid__DOT__R_0._combo__TOP__hybrid__DOT__R_0__13(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_1._combo__TOP__hybrid__DOT__R_1__14(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_0._combo__TOP__hybrid__DOT__G_0__15(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_1._combo__TOP__hybrid__DOT__G_1__16(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_0._combo__TOP__hybrid__DOT__B_0__17(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_1._combo__TOP__hybrid__DOT__B_1__18(vlSymsp);
    vlTOPp->_combo__TOP__4(vlSymsp);
    if (((IData)(vlTOPp->clock) & (~ (IData)(vlTOPp->__Vclklast__TOP__clock)))) {
	vlTOPp->_sequent__TOP__5(vlSymsp);
    }
    vlSymsp->TOP__hybrid__DOT__R_0._combo__TOP__hybrid__DOT__R_0__25(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_1._combo__TOP__hybrid__DOT__R_1__26(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_0._combo__TOP__hybrid__DOT__G_0__27(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_1._combo__TOP__hybrid__DOT__G_1__28(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_0._combo__TOP__hybrid__DOT__B_0__29(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_1._combo__TOP__hybrid__DOT__B_1__30(vlSymsp);
    if (((IData)(vlTOPp->clock) & (~ (IData)(vlTOPp->__Vclklast__TOP__clock)))) {
	vlTOPp->_sequent__TOP__7(vlSymsp);
    }
    vlSymsp->TOP__hybrid__DOT__R_0._combo__TOP__hybrid__DOT__R_0__37(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_1._combo__TOP__hybrid__DOT__R_1__38(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_0._combo__TOP__hybrid__DOT__G_0__39(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_1._combo__TOP__hybrid__DOT__G_1__40(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_0._combo__TOP__hybrid__DOT__B_0__41(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_1._combo__TOP__hybrid__DOT__B_1__42(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_0._combo__TOP__hybrid__DOT__R_0__49(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_1._combo__TOP__hybrid__DOT__R_1__50(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_0._combo__TOP__hybrid__DOT__G_0__51(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_1._combo__TOP__hybrid__DOT__G_1__52(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_0._combo__TOP__hybrid__DOT__B_0__53(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_1._combo__TOP__hybrid__DOT__B_1__54(vlSymsp);
    // Final
    vlTOPp->__Vclklast__TOP__clock = vlTOPp->clock;
}

void Vhybrid::_eval_initial(Vhybrid__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vhybrid::_eval_initial\n"); );
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
}

void Vhybrid::final() {
    VL_DEBUG_IF(VL_PRINTF("    Vhybrid::final\n"); );
    // Variables
    Vhybrid__Syms* __restrict vlSymsp = this->__VlSymsp;
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
}

void Vhybrid::_eval_settle(Vhybrid__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vhybrid::_eval_settle\n"); );
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->_settle__TOP__3(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_0._settle__TOP__hybrid__DOT__R_0__7(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_1._settle__TOP__hybrid__DOT__R_1__8(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_0._settle__TOP__hybrid__DOT__G_0__9(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_1._settle__TOP__hybrid__DOT__G_1__10(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_0._settle__TOP__hybrid__DOT__B_0__11(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_1._settle__TOP__hybrid__DOT__B_1__12(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_0._settle__TOP__hybrid__DOT__R_0__19(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_1._settle__TOP__hybrid__DOT__R_1__20(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_0._settle__TOP__hybrid__DOT__G_0__21(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_1._settle__TOP__hybrid__DOT__G_1__22(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_0._settle__TOP__hybrid__DOT__B_0__23(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_1._settle__TOP__hybrid__DOT__B_1__24(vlSymsp);
    vlTOPp->_settle__TOP__6(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_0._settle__TOP__hybrid__DOT__R_0__31(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_1._settle__TOP__hybrid__DOT__R_1__32(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_0._settle__TOP__hybrid__DOT__G_0__33(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_1._settle__TOP__hybrid__DOT__G_1__34(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_0._settle__TOP__hybrid__DOT__B_0__35(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_1._settle__TOP__hybrid__DOT__B_1__36(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_0._settle__TOP__hybrid__DOT__R_0__43(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_1._settle__TOP__hybrid__DOT__R_1__44(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_0._settle__TOP__hybrid__DOT__G_0__45(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_1._settle__TOP__hybrid__DOT__G_1__46(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_0._settle__TOP__hybrid__DOT__B_0__47(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_1._settle__TOP__hybrid__DOT__B_1__48(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_0._settle__TOP__hybrid__DOT__R_0__55(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__R_1._settle__TOP__hybrid__DOT__R_1__56(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_0._settle__TOP__hybrid__DOT__G_0__57(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__G_1._settle__TOP__hybrid__DOT__G_1__58(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_0._settle__TOP__hybrid__DOT__B_0__59(vlSymsp);
    vlSymsp->TOP__hybrid__DOT__B_1._settle__TOP__hybrid__DOT__B_1__60(vlSymsp);
}

VL_INLINE_OPT QData Vhybrid::_change_request(Vhybrid__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_PRINTF("    Vhybrid::_change_request\n"); );
    Vhybrid* __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    // Change detection
    QData __req = false;  // Logically a bool
    return __req;
}

void Vhybrid::_ctor_var_reset() {
    VL_DEBUG_IF(VL_PRINTF("    Vhybrid::_ctor_var_reset\n"); );
    // Body
    clock = VL_RAND_RESET_I(1);
    reset = VL_RAND_RESET_I(1);
    io_R0 = VL_RAND_RESET_I(8);
    io_R1 = VL_RAND_RESET_I(8);
    io_R2 = VL_RAND_RESET_I(8);
    io_R3 = VL_RAND_RESET_I(8);
    io_R4 = VL_RAND_RESET_I(8);
    io_R5 = VL_RAND_RESET_I(8);
    io_R6 = VL_RAND_RESET_I(8);
    io_R7 = VL_RAND_RESET_I(8);
    io_R8 = VL_RAND_RESET_I(8);
    io_G0 = VL_RAND_RESET_I(8);
    io_G1 = VL_RAND_RESET_I(8);
    io_G2 = VL_RAND_RESET_I(8);
    io_G3 = VL_RAND_RESET_I(8);
    io_G4 = VL_RAND_RESET_I(8);
    io_G5 = VL_RAND_RESET_I(8);
    io_G6 = VL_RAND_RESET_I(8);
    io_G7 = VL_RAND_RESET_I(8);
    io_G8 = VL_RAND_RESET_I(8);
    io_B0 = VL_RAND_RESET_I(8);
    io_B1 = VL_RAND_RESET_I(8);
    io_B2 = VL_RAND_RESET_I(8);
    io_B3 = VL_RAND_RESET_I(8);
    io_B4 = VL_RAND_RESET_I(8);
    io_B5 = VL_RAND_RESET_I(8);
    io_B6 = VL_RAND_RESET_I(8);
    io_B7 = VL_RAND_RESET_I(8);
    io_B8 = VL_RAND_RESET_I(8);
    io_e = VL_RAND_RESET_I(1);
    io_ansR = VL_RAND_RESET_I(8);
    io_ansG = VL_RAND_RESET_I(8);
    io_ansB = VL_RAND_RESET_I(8);
    hybrid__DOT__cnt = VL_RAND_RESET_I(5);
    hybrid__DOT___T_36 = VL_RAND_RESET_I(1);
    hybrid__DOT___T_39 = VL_RAND_RESET_I(5);
    hybrid__DOT__cnt_1 = VL_RAND_RESET_I(5);
    hybrid__DOT___T_44 = VL_RAND_RESET_I(1);
    hybrid__DOT___T_47 = VL_RAND_RESET_I(5);
    hybrid__DOT___T_50 = VL_RAND_RESET_I(1);
    hybrid__DOT___T_53 = VL_RAND_RESET_I(1);
    hybrid__DOT__R_2__DOT__tbl_0 = VL_RAND_RESET_I(8);
    hybrid__DOT__R_2__DOT__tbl_1 = VL_RAND_RESET_I(8);
    hybrid__DOT__R_2__DOT__tbl_2 = VL_RAND_RESET_I(8);
    hybrid__DOT__R_2__DOT___GEN_0 = VL_RAND_RESET_I(8);
    hybrid__DOT__R_2__DOT___GEN_1 = VL_RAND_RESET_I(8);
    hybrid__DOT__R_2__DOT___GEN_2 = VL_RAND_RESET_I(8);
    hybrid__DOT__R_2__DOT___T_20 = VL_RAND_RESET_I(1);
    hybrid__DOT__R_2__DOT___GEN_5 = VL_RAND_RESET_I(8);
    hybrid__DOT__R_2__DOT___T_23 = VL_RAND_RESET_I(1);
    hybrid__DOT__R_2__DOT___GEN_10 = VL_RAND_RESET_I(8);
    hybrid__DOT__R_2__DOT___GEN_13 = VL_RAND_RESET_I(8);
    hybrid__DOT__G_2__DOT__tbl_0 = VL_RAND_RESET_I(8);
    hybrid__DOT__G_2__DOT__tbl_1 = VL_RAND_RESET_I(8);
    hybrid__DOT__G_2__DOT__tbl_2 = VL_RAND_RESET_I(8);
    hybrid__DOT__G_2__DOT___GEN_0 = VL_RAND_RESET_I(8);
    hybrid__DOT__G_2__DOT___GEN_1 = VL_RAND_RESET_I(8);
    hybrid__DOT__G_2__DOT___GEN_2 = VL_RAND_RESET_I(8);
    hybrid__DOT__G_2__DOT___T_20 = VL_RAND_RESET_I(1);
    hybrid__DOT__G_2__DOT___GEN_5 = VL_RAND_RESET_I(8);
    hybrid__DOT__G_2__DOT___T_23 = VL_RAND_RESET_I(1);
    hybrid__DOT__G_2__DOT___GEN_10 = VL_RAND_RESET_I(8);
    hybrid__DOT__G_2__DOT___GEN_13 = VL_RAND_RESET_I(8);
    hybrid__DOT__B_2__DOT__tbl_0 = VL_RAND_RESET_I(8);
    hybrid__DOT__B_2__DOT__tbl_1 = VL_RAND_RESET_I(8);
    hybrid__DOT__B_2__DOT__tbl_2 = VL_RAND_RESET_I(8);
    hybrid__DOT__B_2__DOT___GEN_0 = VL_RAND_RESET_I(8);
    hybrid__DOT__B_2__DOT___GEN_1 = VL_RAND_RESET_I(8);
    hybrid__DOT__B_2__DOT___GEN_2 = VL_RAND_RESET_I(8);
    hybrid__DOT__B_2__DOT___T_20 = VL_RAND_RESET_I(1);
    hybrid__DOT__B_2__DOT___GEN_5 = VL_RAND_RESET_I(8);
    hybrid__DOT__B_2__DOT___T_23 = VL_RAND_RESET_I(1);
    hybrid__DOT__B_2__DOT___GEN_10 = VL_RAND_RESET_I(8);
    hybrid__DOT__B_2__DOT___GEN_13 = VL_RAND_RESET_I(8);
    __Vclklast__TOP__clock = VL_RAND_RESET_I(1);
    __Vm_traceActivity = VL_RAND_RESET_I(32);
}
