// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Primary design header
//
// This header should be included by all source files instantiating the design.
// The class here is then constructed to instantiate the design.
// See the Verilator manual for examples.

#ifndef _Vhybrid_H_
#define _Vhybrid_H_

#include "verilated.h"
class Vhybrid__Syms;
class Vhybrid_median5;
class Vhybrid_median5;
class Vhybrid_median5;
class Vhybrid_median5;
class Vhybrid_median5;
class Vhybrid_median5;
class VerilatedVcd;

//----------

VL_MODULE(Vhybrid) {
  public:
    // CELLS
    // Public to allow access to /*verilator_public*/ items;
    // otherwise the application code can consider these internals.
    Vhybrid_median5*   	__PVT__hybrid__DOT__R_0;
    Vhybrid_median5*   	__PVT__hybrid__DOT__R_1;
    Vhybrid_median5*   	__PVT__hybrid__DOT__G_0;
    Vhybrid_median5*   	__PVT__hybrid__DOT__G_1;
    Vhybrid_median5*   	__PVT__hybrid__DOT__B_0;
    Vhybrid_median5*   	__PVT__hybrid__DOT__B_1;
    
    // PORTS
    // The application code writes and reads these signals to
    // propagate new values into/out from the Verilated model.
    VL_IN8(clock,0,0);
    VL_IN8(reset,0,0);
    VL_IN8(io_R0,7,0);
    VL_IN8(io_R1,7,0);
    VL_IN8(io_R2,7,0);
    VL_IN8(io_R3,7,0);
    VL_IN8(io_R4,7,0);
    VL_IN8(io_R5,7,0);
    VL_IN8(io_R6,7,0);
    VL_IN8(io_R7,7,0);
    VL_IN8(io_R8,7,0);
    VL_IN8(io_G0,7,0);
    VL_IN8(io_G1,7,0);
    VL_IN8(io_G2,7,0);
    VL_IN8(io_G3,7,0);
    VL_IN8(io_G4,7,0);
    VL_IN8(io_G5,7,0);
    VL_IN8(io_G6,7,0);
    VL_IN8(io_G7,7,0);
    VL_IN8(io_G8,7,0);
    VL_IN8(io_B0,7,0);
    VL_IN8(io_B1,7,0);
    VL_IN8(io_B2,7,0);
    VL_IN8(io_B3,7,0);
    VL_IN8(io_B4,7,0);
    VL_IN8(io_B5,7,0);
    VL_IN8(io_B6,7,0);
    VL_IN8(io_B7,7,0);
    VL_IN8(io_B8,7,0);
    VL_IN8(io_e,0,0);
    VL_OUT8(io_ansR,7,0);
    VL_OUT8(io_ansG,7,0);
    VL_OUT8(io_ansB,7,0);
    //char	__VpadToAlign33[3];
    
    // LOCAL SIGNALS
    // Internals; generally not touched by application code
    VL_SIG8(hybrid__DOT__cnt,4,0);
    VL_SIG8(hybrid__DOT___T_36,0,0);
    VL_SIG8(hybrid__DOT___T_39,4,0);
    VL_SIG8(hybrid__DOT__cnt_1,4,0);
    VL_SIG8(hybrid__DOT___T_44,0,0);
    VL_SIG8(hybrid__DOT___T_47,4,0);
    VL_SIG8(hybrid__DOT___T_50,0,0);
    VL_SIG8(hybrid__DOT___T_53,0,0);
    VL_SIG8(hybrid__DOT__R_2__DOT__tbl_0,7,0);
    VL_SIG8(hybrid__DOT__R_2__DOT__tbl_1,7,0);
    VL_SIG8(hybrid__DOT__R_2__DOT__tbl_2,7,0);
    VL_SIG8(hybrid__DOT__R_2__DOT___GEN_0,7,0);
    VL_SIG8(hybrid__DOT__R_2__DOT___GEN_1,7,0);
    VL_SIG8(hybrid__DOT__R_2__DOT___GEN_2,7,0);
    VL_SIG8(hybrid__DOT__R_2__DOT___T_20,0,0);
    VL_SIG8(hybrid__DOT__R_2__DOT___GEN_5,7,0);
    VL_SIG8(hybrid__DOT__R_2__DOT___T_23,0,0);
    VL_SIG8(hybrid__DOT__R_2__DOT___GEN_10,7,0);
    VL_SIG8(hybrid__DOT__R_2__DOT___GEN_13,7,0);
    VL_SIG8(hybrid__DOT__G_2__DOT__tbl_0,7,0);
    VL_SIG8(hybrid__DOT__G_2__DOT__tbl_1,7,0);
    VL_SIG8(hybrid__DOT__G_2__DOT__tbl_2,7,0);
    VL_SIG8(hybrid__DOT__G_2__DOT___GEN_0,7,0);
    VL_SIG8(hybrid__DOT__G_2__DOT___GEN_1,7,0);
    VL_SIG8(hybrid__DOT__G_2__DOT___GEN_2,7,0);
    VL_SIG8(hybrid__DOT__G_2__DOT___T_20,0,0);
    VL_SIG8(hybrid__DOT__G_2__DOT___GEN_5,7,0);
    VL_SIG8(hybrid__DOT__G_2__DOT___T_23,0,0);
    VL_SIG8(hybrid__DOT__G_2__DOT___GEN_10,7,0);
    VL_SIG8(hybrid__DOT__G_2__DOT___GEN_13,7,0);
    VL_SIG8(hybrid__DOT__B_2__DOT__tbl_0,7,0);
    VL_SIG8(hybrid__DOT__B_2__DOT__tbl_1,7,0);
    VL_SIG8(hybrid__DOT__B_2__DOT__tbl_2,7,0);
    VL_SIG8(hybrid__DOT__B_2__DOT___GEN_0,7,0);
    VL_SIG8(hybrid__DOT__B_2__DOT___GEN_1,7,0);
    VL_SIG8(hybrid__DOT__B_2__DOT___GEN_2,7,0);
    VL_SIG8(hybrid__DOT__B_2__DOT___T_20,0,0);
    VL_SIG8(hybrid__DOT__B_2__DOT___GEN_5,7,0);
    VL_SIG8(hybrid__DOT__B_2__DOT___T_23,0,0);
    VL_SIG8(hybrid__DOT__B_2__DOT___GEN_10,7,0);
    VL_SIG8(hybrid__DOT__B_2__DOT___GEN_13,7,0);
    //char	__VpadToAlign81[3];
    
    // LOCAL VARIABLES
    // Internals; generally not touched by application code
    VL_SIG8(__Vclklast__TOP__clock,0,0);
    //char	__VpadToAlign89[3];
    VL_SIG(__Vm_traceActivity,31,0);
    
    // INTERNAL VARIABLES
    // Internals; generally not touched by application code
    //char	__VpadToAlign100[4];
    Vhybrid__Syms*	__VlSymsp;		// Symbol table
    
    // PARAMETERS
    // Parameters marked /*verilator public*/ for use by application code
    
    // CONSTRUCTORS
  private:
    Vhybrid& operator= (const Vhybrid&);	///< Copying not allowed
    Vhybrid(const Vhybrid&);	///< Copying not allowed
  public:
    /// Construct the model; called by application code
    /// The special name  may be used to make a wrapper with a
    /// single model invisible WRT DPI scope names.
    Vhybrid(const char* name="TOP");
    /// Destroy the model; called (often implicitly) by application code
    ~Vhybrid();
    /// Trace signals in the model; called by application code
    void trace (VerilatedVcdC* tfp, int levels, int options=0);
    
    // USER METHODS
    
    // API METHODS
    /// Evaluate the model.  Application must call when inputs change.
    void eval();
    /// Simulation complete, run final blocks.  Application must call on completion.
    void final();
    
    // INTERNAL METHODS
  private:
    static void _eval_initial_loop(Vhybrid__Syms* __restrict vlSymsp);
  public:
    void __Vconfigure(Vhybrid__Syms* symsp, bool first);
  private:
    static QData	_change_request(Vhybrid__Syms* __restrict vlSymsp);
  public:
    static void	_combo__TOP__4(Vhybrid__Syms* __restrict vlSymsp);
  private:
    void	_ctor_var_reset();
  public:
    static void	_eval(Vhybrid__Syms* __restrict vlSymsp);
    static void	_eval_initial(Vhybrid__Syms* __restrict vlSymsp);
    static void	_eval_settle(Vhybrid__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__1(Vhybrid__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__2(Vhybrid__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__5(Vhybrid__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__7(Vhybrid__Syms* __restrict vlSymsp);
    static void	_settle__TOP__3(Vhybrid__Syms* __restrict vlSymsp);
    static void	_settle__TOP__6(Vhybrid__Syms* __restrict vlSymsp);
    static void	traceChgThis(Vhybrid__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceChgThis__2(Vhybrid__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceChgThis__3(Vhybrid__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceFullThis(Vhybrid__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceFullThis__1(Vhybrid__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceInitThis(Vhybrid__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void	traceInitThis__1(Vhybrid__Syms* __restrict vlSymsp, VerilatedVcd* vcdp, uint32_t code);
    static void traceInit (VerilatedVcd* vcdp, void* userthis, uint32_t code);
    static void traceFull (VerilatedVcd* vcdp, void* userthis, uint32_t code);
    static void traceChg  (VerilatedVcd* vcdp, void* userthis, uint32_t code);
} VL_ATTR_ALIGNED(128);

#endif  /*guard*/
